package ant;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.EntityID;
import ant.agent.command.AntCommand;

/**
 * 
 * @author Ivan
 * 
 * @param <E>
 */
public abstract class AbstractAntAgent<E extends Human> {

	protected AgentContext context;
	protected StandardWorldModel world;

	public void initial(AgentContext context) {
		this.context = context;
		this.world = context.getWorld();
	}

	public final Human me() {
		return this.context.getHuman();
	}

	public final StandardEntityURN getAgentType() {
		return this.context.getAgentType();
	}

	public final EntityID getID() {
		return this.context.getAgentID();
	}

	public final int getTime() {
		return this.context.getTimestamp();
	}

	public final AgentContext getContext() {
		return this.context;
	}

	public abstract AntCommand think();

	public final AntComponentKit kit() {
		return this.context.getAntComponentKit();
	}

	// @Deprecated
	// public void sendSpeak(AntSpeak speak) {
	// this.context.getAntCommunicationKit().sendSpeak(speak);
	// }
	//
	// @Deprecated
	// public void sendSubcribe(AntSubscribe subscribe) {
	// this.context.getAntCommunicationKit().sendSubscribe(subscribe);
	// }
	//

	// protected AntCommand behave() {
	// boolean executed;
	// executed = false;
	// AntCommand ret = null;
	// if (jobs == null) {
	// jobs = produceJobs();
	// }
	//
	// for (AntJob job : jobs) {
	//
	// boolean shouldExecute = false;
	// if (executed) {
	// job.overtaken();
	// } else {
	// shouldExecute = job.shouldExecute();
	// if (shouldExecute) {
	// this.context.setState(job.getState());
	// ret = job.execute();
	// executed = true;
	// }
	// }
	// }
	//
	// return ret;
	// }
	//
	// protected abstract List<AntJob> produceJobs();
}
