package ant;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import ant.agent.command.AntSpeak;
import ant.agent.command.AntSubscribe;
import ant.exception.AntComponentRegisterException;
import ant.liaison.MessagePropertyCodecComponent;
import ant.liaison.MultiMessageCodec;
import ant.liaison.SingleMessageCodec;
import ant.liaison.channel.assign.ChannelAssignResult.BandwidthLevel;
import ant.liaison.exception.MessagePropertyDescriptionException;
import ant.liaison.message.AbstractCivilianMessage;
import ant.liaison.message.IMessage;

/**
 * TODO 延迟发送问题?
 * 
 * @author Fun, Ivan
 * 
 */
public abstract class AbstractAntCommunicationKit extends AbstractAntKit {
	private static final Log log = LogFactory.getLog(AbstractAntCommunicationKit.class);
	private SingleMessageCodec smc = null;
	private MultiMessageCodec mmc = null;
	private MessagePropertyCodecComponent mpcc = null;

	public AbstractAntCommunicationKit() throws AntComponentRegisterException {
		super();
		registerComponent(MessagePropertyCodecComponent.class);
	}

	@Override
	public void update(AgentContext context) {
		super.update(context);
	}

	protected abstract void sendRadio(IMessage message);

	protected abstract void sendVoice(IMessage message);

	public abstract Set<IMessage> getRadioReceiveBox();

	public abstract Set<IMessage> getRadioBoxWithSelf();

	public abstract Set<IMessage> getVoiceReceiveBox();

	public abstract Set<AbstractCivilianMessage> getMessagesFromCivilian();

	public abstract List<AntSpeak> pullallSpeak();

	public abstract AntSubscribe pullSubscribe();

	public List<AntSpeak> pullpreSpeaks() {
		return new ArrayList<AntSpeak>();
	}

	public AntSubscribe pullpreSubscribe() {
		return null;
	}

	public final MultiMessageCodec getMultiMessageCodec() {
		if (mmc == null) {
			try {
				if (mpcc == null) {
					this.mpcc = (MessagePropertyCodecComponent) this
							.getAntComponent(MessagePropertyCodecComponent.class);
				}
				this.mmc = new MultiMessageCodec(mpcc);
			} catch (MessagePropertyDescriptionException e) {
				// TODO pseudo codec instead
				log.fatal(e);
				throw new RuntimeException();
			}
		}
		return mmc;
	}

	public final SingleMessageCodec getSingleMessageCodec() {
		if (smc == null) {
			try {
				if (mpcc == null) {
					this.mpcc = (MessagePropertyCodecComponent) this
							.getAntComponent(MessagePropertyCodecComponent.class);
				}
				this.smc = new SingleMessageCodec(mpcc);
			} catch (MessagePropertyDescriptionException e) {
				// TODO pseudo codec instead
				log.fatal(e);
				throw new RuntimeException();
			}
		}
		return smc;
	}

	public boolean isNoRadio() {
		return false;
	}

	public BandwidthLevel getBandwidthLevel() {
		return BandwidthLevel.Unknown;
	}
}
