package ant;

import java.util.HashSet;
import java.util.Set;

import ant.liaison.message.IMessage;

/**
 * 
 * @author Ivan
 *
 */
public abstract class AbstractMessageProducerComponent implements MessageProducer, AntComponent {
	
	private Set<IMessage> voiceMessages = new HashSet<IMessage>();
	private Set<IMessage> radioMessages = new HashSet<IMessage>();
	
	protected final void addVoiceMessage(IMessage msg) {
		voiceMessages.add(msg);
	}
	
	protected final void addRadioMessage(IMessage msg) {
		radioMessages.add(msg);
	}
	
	@Override
	public final Set<IMessage> pollVoiceMessages() {
		HashSet<IMessage> temp = new HashSet<IMessage>(voiceMessages);;
		voiceMessages.clear();
		return temp;
	}
	
	@Override
	public final Set<IMessage> pollRadioMessages() {
		HashSet<IMessage> temp = new HashSet<IMessage>(radioMessages);;
		radioMessages.clear();
		return temp;
	}
	
}
