package ant.agent;

import java.util.Collection;
import java.util.EnumSet;

import rescuecore2.messages.Command;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import ant.AbstractAntAgent;

/**
 * 
 * @author Ivan
 *
 * @param <E>
 */
public final class CommonPseudoAgent<E extends Human> extends CommonAgent<E> {

	private EntityID id;
	private StandardEntityURN pseudoURN;

	public CommonPseudoAgent(AbstractAntAgent<E> ant, int pseudoID, StandardEntityURN fakeURN) {
		super(ant);
		this.id = new EntityID(pseudoID);
		this.pseudoURN = fakeURN;
	}

	@Override
	public StandardEntityURN getAgentType() {
		return pseudoURN;
	}

	@Override
	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(this.pseudoURN);
	}
	
	@Override
	public EntityID getID() {
		return id;
	}
	
	@Override
	protected E me() {
		return (E) new PseudoHuman(id);
	}
	
	private class PseudoHuman extends Human {
		
		protected PseudoHuman(EntityID id) {
			super(id);
		}

		@Override
		public StandardEntityURN getStandardURN() {
			return pseudoURN;
		}

		@Override
		protected Entity copyImpl() {
			return null;
		}
		
	}

	@Override
	protected void exceptionThink(int time, ChangeSet changed, Collection<Command> heard) {
	}
}
