package ant.agent.behavior;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.config.Config;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.StandardWorldModel;
import ant.AgentContext;
import ant.ConfigKey;

/**
 * 
 * @author Fun
 * 
 */
public class FBBehavior extends AntBehavior<FireBrigade> {
	private static Log log = LogFactory.getLog(FBBehavior.class);

	private static final float OUT_OF_WATER_LEVEL = 0.05f;

	private StandardWorldModel world;
	private int maxWater;
	private int maxPower;
	private int maxDistance;
	private FireBrigade agent;

	public FBBehavior(AgentContext context) {
		super(context);
		this.world = context.getWorld();
		this.agent = (FireBrigade) context.getHuman();
		Config config = context.getConfig();
		this.maxWater = ConfigKey.getFireMaxDistance(config);
		this.maxPower = ConfigKey.getFireMaxPower(config);
		this.maxDistance = ConfigKey.getFireMaxDistance(config);
	}

	public int getMaxDistance() {
		return maxDistance;
	}

	public int getMaxPower() {
		return maxPower;
	}

	public int getMaxWater() {
		return maxWater;
	}

	public boolean isOutOfWater() {
		return agent.getWater() < OUT_OF_WATER_LEVEL * maxWater || agent.getWater() < maxPower;
	}
}
