package ant.agent.job.at;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;

/**
 * 
 * @author fun
 * 
 */
public class DecisionManager {

	private static Log log = LogFactory.getLog(DecisionManager.class);

	public int maxWater;
	public static final int MAX_BURRIEDNESS = 61;
	public static final int MAX_HP_WILL_DIE = 5000;
	public static final int MIN_HP_HELPLESS = 2000;
	public static final int MIN_BURIEDNESS_HELPLESS = 20;

	public static List<Building> ignoreBurningBuildings(List<Building> buildings) {
		List<Building> result = new ArrayList<Building>();
		for (Building next : buildings) {
			if (!next.isOnFire()) {
				if (next.isFierynessDefined()) {
					if (Fieryness.UNBURNT == next.getFierynessEnum()
							|| Fieryness.WATER_DAMAGE == next
									.getFierynessEnum()
							|| Fieryness.MINOR_DAMAGE == next
									.getFierynessEnum()
							|| Fieryness.MODERATE_DAMAGE == next
									.getFierynessEnum()
							|| Fieryness.SEVERE_DAMAGE == next
									.getFierynessEnum()) {
						result.add(next);
					}
				} else {
					result.add(next);
				}
			}
		}
		return result;
	}

}
