package ant.agent.job.at;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.agent.command.AntCommand;
import ant.agent.command.AntRest;
import ant.agent.job.AbstractJob;
import ant.agent.job.JobState;
import ant.utils.blockade.RoadUtils;

/**
 * 
 * @author Fun
 *
 */
public class IsStuckOrBuriedCallHelpJob extends AbstractJob<Human>{

	private Human me;
	
	public IsStuckOrBuriedCallHelpJob(AgentContext context) {
		super(context);
		me = context.getHuman();
	}

	@Override
	public void overtaken() {
		state = JobState.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		
		if (behavior.isBuried()) {
			// 发送被埋消息
			
//			Human me = context.getHuman();
//			int hp = 10000;
//			int damage = 0;
//			int buriedness = 0;
//			if (me.isHPDefined()) {
//				hp = me.getHP();
//			}
//			if (me.isDamageDefined()) {
//				damage = me.getDamage();
//			}
//			if (me.isBuriednessDefined()) {
//				buriedness = me.getBuriedness();
//			}
//			context.getAntCommunicationKit().sendSpeak(new MAgentBuried(hp,damage,buriedness));

			// 智能体被埋，且被埋的房屋入口处有路障 ，这里发送两条消息?
			Area area = behavior.getMyPosition();

			if (area instanceof Building) {
				Building b = (Building) area;
				if (behavior.getEntranceRoad(b) != null) {
					EntityID id = RoadUtils.getNearestBlockadeInArea(context.getWorld(),behavior.x(), behavior.y(), behavior.getEntranceRoad(b));
					Blockade blockade = null;
					if(id != null){
						blockade = (Blockade) context.getWorld().getEntity(id);
					}

					if (blockade != null) {
						// 发送清障消息
						// TODO
					}
				}
			}

			state = JobState.BuriedResting;
			return true;
		} else if (behavior.isStuck(false)) {
			// 发送Stucked信息
//			AgentIsStuckMessage agentIsStuckMessage = new AgentIsStuckMessage(
//					agent.location().getID());
//			agent.sendMessage(agentIsStuckMessage, MessagePriority.High);
			state = JobState.StuckResting;
			// TA
//			if (agent.getMeAsHuman().getStandardURN() == StandardEntityURN.AMBULANCE_TEAM) {
//				Random random;
//				int n;
//				random = agent.getRandomSource();
//				n = random.nextInt(2);
//				if (n == 0) {
//					return true;
//				} else {
//					return false;
//				}
//			}
			return false;
		} else {

			// 智能体被堵在房屋里，但是没有Buriedness
			// 这里仍然需要发送被堵的消息
			return false;
		}
	}

	@Override
	public AntCommand execute() {
		return new AntRest(context.getTimestamp());
	}

	@Override
	public String getJobName() {
		// TODO Auto-generated method stub
		return IsStuckOrBuriedCallHelpJob.class.getName();
	}

}
