package ant.agent.job.at;

import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;
import ant.agent.job.JobState;

/**
 * 
 * @author Fun
 *
 */
public class SaveHumanTask {
	EntityID human;
	StandardEntity location;
	int deathTime;

	public SaveHumanTask(EntityID human, StandardEntity location, int deathTime) {
		setHumanAndLocation(human, location, deathTime);
	}

	public int getDeathTime() {
		return deathTime;
	}

	public void setHumanAndLocation(EntityID c, StandardEntity l, int d) {
		this.human = c;
		this.location = l;
		this.deathTime = d;

	}

	public void setDeathtime(int d) {
		this.deathTime = d;
	}

	public EntityID getHuman() {
		if (human == null) {
			return null;
		} else {
			return human;
		}
	}

	public StandardEntity getLocationOfHuman() {
		return location;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final SaveHumanTask other = (SaveHumanTask) obj;
		if (this.human != other.human
				&& (this.human == null || !this.human.equals(other.human))) {
			return false;
		}
		return true;
	}

	@Override
	public int hashCode() {
		int hash = 3;
		hash = 37 * hash + (this.human != null ? this.human.hashCode() : 0);
		return hash;
	}

	public JobState getState() {
		return JobState.WillSaveHuman;
	}

	@Override
	public String toString() {
		return "SaveTask(" + human + ", " + location + ")";
	}
}

