package ant.agent.job.fb;

import rescuecore2.config.Config;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardWorldModel;
import ant.AgentContext;
import ant.ConfigKey;
import ant.agent.job.AbstractJob;

/**
 * 
 * @author Oliver
 * 
 */
public abstract class AbstractExtinguishJob extends AbstractJob<FireBrigade> {
	protected StandardWorldModel world;
	protected int ignoreTimestamp;
	protected int maxPower;
	protected int maxDistance;
	protected int maxWater;
	protected Human me;

	public AbstractExtinguishJob(AgentContext context) {
		super(context);
		Config config = context.getConfig();
		this.world = context.getWorld();
		this.ignoreTimestamp = ConfigKey.getIgnoreTime(config);
		this.maxPower = ConfigKey.getFireMaxPower(config);
		this.maxDistance = ConfigKey.getFireMaxDistance(config);
		this.maxWater = ConfigKey.getFireMaxWater(config);
		this.me = context.getHuman();
	}

	protected boolean isInExtinguishRange(Building b) {
		return Math.hypot(b.getX() - me.getX(), b.getY() - me.getY()) <= maxDistance;
	}

	protected boolean canExtinguish() {
		return agent.isWaterDefined() && agent.getWater() > 0;
	}
}
