package ant.agent.job.fb;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class BuidlingQualification {
	private static Log log = LogFactory.getLog(BuidlingQualification.class);

	private static final int INVALID_VALUE = -1;
	private int hullRadius;
	private double distanceToNearestEdge;
	private boolean isInSmallHull;
	private boolean isValid;

	public BuidlingQualification() {
		clear();
	}

	void clear() {
		this.hullRadius = INVALID_VALUE;
		this.distanceToNearestEdge = INVALID_VALUE;
		this.isInSmallHull = false;
		this.isValid = false;
	}

	void setQualificationValue(int hullRadius, boolean isInSmallHull) {
		if (isValid) {
			log.error("setQualificationValue into a valid qulification!");
		}

		this.hullRadius = hullRadius;
		this.isInSmallHull = isInSmallHull;
		this.isValid = true;
	}

	void setQualificationValue(int hullRadius, boolean isInSmallHull, double distanceToNearestEdge) {
		if (isValid) {
			log.error("setQualificationValue into a valid qulification!");
		}

		this.hullRadius = hullRadius;
		this.isInSmallHull = isInSmallHull;
		this.distanceToNearestEdge = distanceToNearestEdge;
		this.isValid = true;
	}

	public double getHullRadius() {
		return hullRadius;
	}

	public double getDistanceToNearestEdge() {
		return distanceToNearestEdge;
	}

	public boolean isInSmallHull() {
		return isInSmallHull;
	}

	public boolean isValid() {
		return isValid;
	}
}