package ant.agent.job.fb;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.agent.command.AntCommand;
import ant.agent.command.AntMove;
import ant.agent.command.AntRest;
import ant.agent.job.AbstractJob;
import ant.map.component.AbstractRouteComponent;
import ant.map.objects.RouteResult;

/**
 * 
 * @author Oliver
 * 
 * @param <E>
 */
public class GoToAreaJob<E extends Human> extends AbstractJob<E> {
	private static Log log = LogFactory.getLog(GoToAreaJob.class);
	
	private EntityID target;
	private AbstractRouteComponent arc;

	public GoToAreaJob(AgentContext context) {
		super(context);
		this.target = new EntityID(959);
		this.arc = context.getAntComponentKit().getAbstractRouteComponent();
	}

	@Override
	public void overtaken() {
		// TODO Auto-generated method stub

	}

	@Override
	public boolean shouldExecute() {
		return true;
	}

	@Override
	public AntCommand execute() {
		EntityID here = context.getHuman().getPosition();
		RouteResult route = arc.search(here, agent.getX(), agent.getY(), target);
		log.info("Search from:" + here + " to:" + target + " is:" + route.hasAcceptableRoute());
		if (route.hasAcceptableRoute()) {
			return new AntMove(context.getTimestamp(), route.getMoveRoute());
		} else {
			return new AntRest(context.getTimestamp());
		}
	}

	@Override
	public String getJobName() {
		return getClass().getName();
	}

}
