package ant.agent.job.fb;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.StandardEntity;
import ant.AgentContext;
import ant.ConfigKey;
import ant.agent.job.universal.AdvancedStuckInBuildingJob;
import ant.component.universal.BuildingConditionComponent;
import ant.component.universal.BuildingConditionComponent.BuildingCondition;

public class StuckInBuildingJobForFB extends AdvancedStuckInBuildingJob<FireBrigade> {
	private static Log log = LogFactory.getLog(StuckInBuildingJobForFB.class);

	private int maxDistance;
	private BuildingConditionComponent bcc;

	public StuckInBuildingJobForFB(AgentContext context) {
		super(context);
		this.maxDistance = ConfigKey.getFireMaxDistance(context.getConfig());
		this.bcc = (BuildingConditionComponent) context.getAntComponentKit().getAntComponent(
				BuildingConditionComponent.class);
	}

	@Override
	protected boolean isStuck(int checkStep) {
//		if (context.getTimestamp() <= 6) {
//			log.info("@" + context.getTimestamp() + " set stuck!");
//			return true;
//		}
		if (super.isStuck(checkStep) && !hasBurningBuildingInExtinguishRange()) {
			return true;
		}
		return false;
	}

	private boolean hasBurningBuildingInExtinguishRange() {
		for (StandardEntity entity : world.getObjectsInRange(me, maxDistance)) {
			if (entity instanceof Building) {
				BuildingCondition bc = bcc.getBuildingCondition(entity.getID());
				if (bc != null
						&& bc.isOnFire()
						&& Math.hypot(me.getX() - bc.getBuilding().getX(), me.getY()
								- bc.getBuilding().getY()) < maxDistance) {
					return true;
				}
			}
		}
		return false;
	}

}
