package ant.agent.job.universal;

import rescuecore2.standard.entities.Human;
import ant.AgentContext;
import ant.agent.command.AntCommand;
import ant.agent.command.AntRest;
import ant.agent.job.AbstractJob;
import ant.agent.job.JobState;

/**
 * 
 * @author Oliver
 * 
 */
public class AgentBuriedJob<E extends Human> extends AbstractJob<E> {

	private Human me;

	public AgentBuriedJob(AgentContext context) {
		super(context);
		this.me = context.getHuman();
	}

	@Override
	public String getJobName() {
		return "RoutineMessageJob";
	}

	@Override
	public void overtaken() {
		this.state = JobState.Inactive;
	}

	@Override
	public void overleap() {
		super.overleap();
		this.state = JobState.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		if (me.isBuriednessDefined() && me.getBuriedness() > 0) {
			this.state = JobState.BuriedResting;
			return true;
		} else {
			return false;
		}
	}

	@Override
	public AntCommand execute() {
		return new AntRest(context.getTimestamp());
	}
}
