package ant.agent.job.universal;

import java.util.List;

import org.jfree.util.Log;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.agent.command.AntCommand;
import ant.agent.command.AntMove;
import ant.agent.job.AbstractJob;
import ant.agent.job.JobState;
import ant.agent.job.at.AgentMover;

/**
 * 
 * @author Fun
 *
 */
public class AntSaveMyselfJob extends AbstractJob<Human>{

	private List<EntityID> path;
	private AgentMover amover;
	
	public AntSaveMyselfJob(AgentContext context) {
		super(context);
		amover = new AgentMover(context);
	}

	@Override
	public void overtaken() {
		state = JobState.Inactive;
		path = null;		
	}

	@Override
	public boolean shouldExecute() {
		if ((state == JobState.Inactive || state == JobState.SavingMyself)
				&& shouldGoToRefuge()) {

			Refuge refuge =behavior.getNearestRefuge();
			// FIXME
			if (refuge !=null && amover.canMove(refuge.getID())) {
				this.path = amover.getPath();
				state = JobState.SavingMyself;
				return true;
			} else {
				// 发送信息 PF 清理路障
//				EntityID nextArea = amover.getNextAreaStatic(refugeid);
//				if (nextArea != null) {
//					if (amover.frontBlocked(nextArea)) {
//						Area here = (Area) agent.getWorld().getEntity(
//								agent.me().getPosition());
//						Edge e = here.getEdgeTo(nextArea);
//						if (e != null) {
//							Area next = (Area) agent.getWorld().getEntity(
//									nextArea);
//							log.info("sendMsg:cleanHigh " + next.getID()
//									+ " Agent:" + agent.getID());
//							agent.pushMessage(new BitCleanEntityHigh(next,
//									(int) e.getMidx(), (int) e.getMidy()));
//						} else {
//							log.fatal("Area:" + here.getID()
//									+ " has no neighbour:" + nextArea
//									+ ". Agent:" + agent.getID());
//						}
//					}
//				}
				return false;
			}
		}

		return false;
	}

	@Override
	public AntCommand execute() {
		if(path == null){
			Log.error(this.getJobName()+" no path!");
			return null;
		}
		amover.record();
		return new AntMove(context.getTimestamp(),path);
	}

	@Override
	public String getJobName() {
		return AntSaveMyselfJob.class.getName();
	}
	
	private boolean shouldGoToRefuge() {
		Human me = context.getHuman();
//		if (me.getHP() < 1000) {
//			return true;
//		}else 
		if (me.getHP() < 3000 && me.getDamage() > 0) {
			return true;
		} else if (me.getHP() < me.getDamage() * 15) {
			return true;
		} else if (me.getDamage() > 50) {
			return true;
		}
		return false;
	}

}
