package ant.agent.job.universal;

import rescuecore2.standard.entities.Human;
import ant.AgentContext;
import ant.ConfigKey;
import ant.agent.command.AntCommand;
import ant.agent.command.AntRest;
import ant.agent.job.AbstractJob;
import ant.agent.job.JobState;

/**
 * 
 * @author Ivan
 * 
 */
public class IgnorationJob<E extends Human> extends AbstractJob<E> {

	public IgnorationJob(AgentContext context) {
		super(context);
	}

	@Override
	public void overtaken() {
		state = JobState.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		if (context.getTimestamp() < ConfigKey.getIgnoreTime(context.getConfig())) {
			return true;
		}
		
		if (context.getHuman().isBuriednessDefined())
			if (context.getHuman().getBuriedness() > 0)
				return true;

		if (context.getHuman().isHPDefined())
			if (context.getHuman().getHP() <= 0)
				return true;

		return false;
	}

	@Override
	public AntCommand execute() {
		return new AntRest(context.getTimestamp());
	}

	@Override
	public String getJobName() {
		return IgnorationJob.class.getName();
	}

}
