package ant.agent.job.universal;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Human;
import ant.AgentContext;
import ant.agent.command.AntCommand;
import ant.agent.job.AbstractJob;
import ant.agent.job.JobState;

/**
 * 
 * @author Ivan
 *
 */
public abstract class NeverJob<E extends Human> extends AbstractJob<E> {
	private static final Log log = LogFactory.getLog(NeverJob.class);
	
	public NeverJob(AgentContext context) {
		super(context);
	}

	@Override
	public final AntCommand execute() {
		throw new RuntimeException("Should not executed");
	}

	@Override
	public void overleap() {
		super.overleap();
		this.state = JobState.Inactive;
	}
	
	@Override
	public final void overtaken() {
		this.state = JobState.Inactive;
	}

	@Override
	public final boolean shouldExecute() {
		executeInternal();
		return false;
	}

	protected abstract void executeInternal();
}
