package ant.component.fb;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import ant.AntComponent;

/**
 * 
 * @author Oliver
 * @depend {@link FireSimulatorComponent}
 */
public class EstimationFireSplitComponent extends AbstractFireSpliteComponent implements
		AntComponent {
	private static Log log = LogFactory.getLog(EstimationFireSplitComponent.class);

	@Override
	protected void initial() {
	}

	@Override
	public void update() {
		split();
		fixFireSimulatorBug();
		// fsc.makeCorrection();
	}

	private void fixFireSimulatorBug() {
		Iterator<Set<FireBuilding>> setIt = splitSetResult.iterator();
		Iterator<List<FireBuilding>> listIt = splitListResult.iterator();
		for (; setIt.hasNext() && listIt.hasNext();) {
			Set<FireBuilding> set = setIt.next();
			listIt.next();
			HashSet<FireBuilding> aroundBuildings = new HashSet<FireBuilding>();
			boolean isSplitPureSimulatedOnFire = true;
			for (FireBuilding fb : set) {
				if (fb.getCondition().isOnFire()) {
					isSplitPureSimulatedOnFire = false;
					break;
				}
				for (Iterator<Entry<FireBuilding, Float>> it = fb.getNearFireBuildings().entrySet()
						.iterator(); it.hasNext();) {
					Entry<FireBuilding, Float> entry = it.next();
					FireBuilding nearFireBuilding = entry.getKey();
					if (set.contains(nearFireBuilding)
							|| aroundBuildings.contains(nearFireBuilding)) {
						continue;
					}
					aroundBuildings.add(nearFireBuilding);
				}
			}
			if (!isSplitPureSimulatedOnFire) {
				continue;
			}

			for (FireBuilding fb : set) {
				// restore values from condition
				// fb.updateFromCondition();
				fb.restoreCondition();
			}
			setIt.remove();
			listIt.remove();

			// boolean isAroundBuildingUnBurnt = true;
			// for (FireBuilding aroundBuilding : aroundBuildings) {
			// Fieryness estiFieryness =
			// aroundBuilding.getCurrentEstiFierynessEnum();
			// Fieryness fieryness =
			// aroundBuilding.getCondition().getFierynessEnum();
			// if ((estiFieryness != Fieryness.UNBURNT) && (fieryness !=
			// Fieryness.UNBURNT)) {
			// isAroundBuildingUnBurnt = false;
			// }
			// // if (aroundBuilding.getCurrentEstiFierynessEnum() !=
			// // StandardEntityConstants.Fieryness.UNBURNT) {
			// // isAroundBuildingUnBurnt = false;
			// // }
			// }
			//
			// if (isAroundBuildingUnBurnt) {
			// // log.info("fixFireSimulatorBug:" + set);
			// for (FireBuilding fb : set) {
			// // restore values from condition
			// // fb.updateFromCondition();
			// fb.restoreCondition();
			// }
			// setIt.remove();
			// listIt.remove();
			// }
		}

	}

	@Override
	public String getComponentName() {
		return getClass().getName();
	}

	@Override
	protected boolean isFireBuildingFitSpliteCondition(FireBuilding fireBuilding) {
		if (fireBuilding.isCurrentEstiOnFire()) {
			return true;
		}
		return false;
	}
}
