package ant.component.fb;

import ant.AntComponent;
import ant.component.universal.BuildingConditionComponent.BuildingCondition;

/**
 * 
 * @author Oliver
 * @depend {@link FireSimulatorComponent}
 */
public class ExplorationFireSplitComponent extends AbstractFireSpliteComponent implements
		AntComponent {
	private static final int NO_RECENT_TIME = 20;

	@Override
	protected void initial() {
	}

	@Override
	public void update() {
		split();
	}

	@Override
	public String getComponentName() {
		return getClass().getName();
	}

	@Override
	protected boolean isFireBuildingFitSpliteCondition(FireBuilding fireBuilding) {
		BuildingCondition condition = fireBuilding.getCondition();

		if (condition.getTimestamp() < 0
				|| context.getTimestamp() - condition.getTimestamp() > NO_RECENT_TIME) {
			if (!condition.isOnFire() && fireBuilding.isCurrentEstiOnFire()) {
				return true;
			}
		}
		return false;
	}
}
