package ant.component.fb;

import java.util.List;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.StandardWorldModel;
import ant.AgentContext;
import ant.AntComponent;
import ant.component.fb.AbstractFireConvexHullComponent.Hull;

/**
 * 
 * @author Oliver
 * @depend {@link FireSplitComponent}
 */
public class FireConvexHullComponent extends AbstractFireConvexHullComponent<Hull> implements
		AntComponent {
	private static Log log = LogFactory.getLog(FireConvexHullComponent.class);
	private FireSplitComponent fsc;

	@Override
	public String getComponentName() {
		return getClass().getName();
	}

	@Override
	public void initial(AgentContext context, StandardWorldModel world) {
		this.fsc = (FireSplitComponent) context.getAntComponentKit().getAntComponent(
				FireSplitComponent.class);
	}

	@Override
	public void update() {
		calHull();
	}

	@Override
	protected AbstractFireSpliteComponent getFireSpliteComponent() {
		return fsc;
	}

	@Override
	protected Hull newHullInstance(List<FireBuilding> buildingsOnHull,
			Set<FireBuilding> buildingsInHull, int id) {
		return new Hull(buildingsOnHull, buildingsInHull, id);
	}
}
