package ant.component.fb;

import java.util.HashMap;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardWorldModel;
import ant.component.universal.BuildingConditionComponent.BuildingCondition;

/**
 * 
 * @author Sarah, Oliver
 * 
 */
public class FireTraceBuilding extends FireBuilding {
	private static Log log = LogFactory.getLog(FireTraceBuilding.class);

	private StandardWorldModel world;
	private RealTimeFireTraceBuildingManagerComponent rtftc;

	private int affectRange;

	public FireTraceBuilding(RealTimeFireTraceBuildingManagerComponent rtftc, StandardWorldModel world,
			Building building, BuildingCondition condition) {
		super();
		this.world = world;
		this.building = building;
		this.rtftc = rtftc;
		this.affectRange = AFFECT_RANGE;
		this.condition = condition;
		this.nearFireBuildings = new HashMap<FireBuilding, Float>();
		initWalls();
	}

	@Override
	protected void initialNearFireBuildings() {
		affectRange += getDistanceToWalls();
		for (StandardEntity entity : world.getObjectsInRange(building, affectRange)) {
			if (entity instanceof Building) {
				FireTraceBuilding fireTraceBuilding = rtftc.getHalfTracedBuilding(entity.getID());
				if (fireTraceBuilding.equals(this)) {
					continue;
				} else {
					nearFireBuildings.put(fireTraceBuilding, new Float(-1));
				}
			}
		}
	}

	public void calConnectValue() {
		initialNearFireBuildings();
		initWallValues();
	}

	@Override
	public String toString() {
		return "FireTraceBuilding:" + building.getID();
	}
}
