package ant.component.pf;

import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.pf.spot.AbstractSpot;
import ant.map.jigsaw.JigsawAttach;
import ant.map.jigsaw.JigsawAvenue;
import ant.map.jigsaw.JigsawType;

/**
 * 
 * @author Ivan
 * 
 */
public class ObjectiveJigsawAvenue extends ObjectiveJigsaw {

	private JigsawAvenue ja;

	public ObjectiveJigsawAvenue(AgentContext context, JigsawAvenue ja, int objectiveID) {
		super(context, ja, objectiveID);
		this.ja = ja;
	}

	@Override
	public JigsawType getJigsawType() {
		return JigsawType.Avenue;
	}

	@Override
	protected boolean isInvaild(AbstractSpot spot) {
		if (super.isInvaild(spot))
			return true;

		EntityID where = spot.getWhere();

		if (ja.contains(where))
			return false;
		
		for (JigsawAttach attach : ja.getAttaches()) {
			if (attach.contains(where)) return false;
		}
		
		return true;
	}

	public JigsawAvenue getJigsawAvenue() {
		return ja;
	}
}
