package ant.component.pf;

import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.pf.spot.AbstractSpot;
import ant.map.jigsaw.JigsawAttach;
import ant.map.jigsaw.JigsawCross;
import ant.map.jigsaw.JigsawType;

/**
 * 
 * @author Ivan
 *
 */
public class ObjectiveJigsawCross extends ObjectiveJigsaw {

	// private int octopusSize = 0;
	private JigsawCross jc;
	
	public ObjectiveJigsawCross(AgentContext context, JigsawCross jc, int objectiveID) {
		super(context, jc, objectiveID);
		this.jc = jc;
		// calcOctopus(jc);
	}
	
	@Override
	protected boolean isInvaild(AbstractSpot spot) {
		if (super.isInvaild(spot))
			return true;

		EntityID where = spot.getWhere();

		if (jc.contains(where))
			return false;
		
		for (JigsawAttach attach : jc.getAttaches()) {
			if (attach.contains(where)) return false;
		}
		
		return true;
	}
	

//	private void calcOctopus(JigsawCross jc) {
//		int c = jc.get().size();
//		Set<EntityID> temp = new HashSet<EntityID>();
//		for (JigsawAttach att : jc.getAttaches()) {
//			temp.addAll(att.get());
//		}
//		for (JigsawAvenue ja : jc.getAvenues()) {
//			c += ja.get().size();
//			for (JigsawAttach att : ja.getAttaches()) {
//				temp.addAll(att.get());
//			}
//		}
//		c += temp.size();
//		this.octopusSize = c;
//	}

	@Override
	public JigsawType getJigsawType() {
		return JigsawType.Cross;
	}

//	@Override
//	protected void addSpotInternal(AbstractSpot spot) {
//		// TODO check type and content
//		spots.add(spot);
//	}
//
//	public int getOctopusSize() {
//		return this.octopusSize;
//	}
	
}
