package ant.component.pf;

import rescuecore2.standard.entities.StandardWorldModel;
import ant.AgentContext;
import ant.AntComponent;

/**
 * 
 * @author Ivan
 * 
 * @depend {@link ObjectiveRaceComponent}
 */
public class ObjectiveProbeComponent implements AntComponent {

	private ObjectiveRaceComponent opc;
	private Race race;
	private ObjectiveProbeSpriteComponent psc;
	private ObjectiveProbeWorkerComponent pwc;

	@Override
	public String getComponentName() {
		return ObjectiveProbeComponent.class.getName();
	}

	@Override
	public void initial(AgentContext context, StandardWorldModel world) {
		this.opc = (ObjectiveRaceComponent) context.getAntComponentKit().getAntComponent(ObjectiveRaceComponent.class);
		this.race = opc.getMyRace();
		if (race == Race.Sprite) {
			this.psc = new ObjectiveProbeSpriteComponent();
			this.psc.initial(context, world);
		} else {
			this.pwc = new ObjectiveProbeWorkerComponent();
			this.pwc.initial(context, world);
		}
	}

	@Override
	public void update() {
		if (race == Race.Sprite) {
			this.psc.update();
		} else {
			this.pwc.update();
		}
	}
	
	public ObjectiveProbeSpriteComponent getProbeSpriteComponent() {
		return psc;
	}

	public ObjectiveProbeWorkerComponent getProbeWorkerComponent() {
		return pwc;
	}
}
