package ant.component.pf.adv;

import rescuecore2.standard.entities.StandardWorldModel;
import ant.AgentContext;
import ant.AntComponent;
import ant.component.pf.ObjectiveRaceComponent;
import ant.component.pf.Race;

/**
 * 
 * @author Ivan
 * @depend {@link ObjectiveRaceComponent}
 */
public class ObjectiveAdvProbeComponent implements AntComponent {
	
	private ObjectiveRaceComponent opc;
	private Race race;
	private ObjectiveAdvProbeSpriteComponent oapsc;
	private ObjectiveAdvProbeWorkerComponent oapwc;

	@Override
	public String getComponentName() {
		return ObjectiveWantedComponent.class.getName();
	}

	@Override
	public void initial(AgentContext context, StandardWorldModel world) {
		this.opc = (ObjectiveRaceComponent) context.getAntComponentKit().getAntComponent(ObjectiveRaceComponent.class);
		this.race = opc.getMyRace();
		if (race == Race.Sprite) {
			this.oapsc = new ObjectiveAdvProbeSpriteComponent();
			this.oapsc.initial(context, world);
		} else {
			this.oapwc = new ObjectiveAdvProbeWorkerComponent();
			this.oapwc.initial(context, world);
		}
	}

	@Override
	public void update() {
		if (race == Race.Sprite) {
			this.oapsc.update();
		} else {
			this.oapwc.update();
		}
	}
	
	public ObjectiveAdvProbeSpriteComponent getObjectiveAdvProbeSpriteComponent() {
		return oapsc;
	}

	public ObjectiveAdvProbeWorkerComponent getObjectiveAdvProbeWorkerComponent() {
		return oapwc;
	}
}
