package ant.component.pf.adv;

import rescuecore2.standard.entities.StandardWorldModel;
import ant.AgentContext;
import ant.AntComponent;
import ant.component.pf.ObjectiveRaceComponent;
import ant.component.pf.Race;

/**
 * 
 * @author Ivan
 *
 */
public class ObjectiveWantedComponent implements AntComponent {
	
	private ObjectiveRaceComponent opc;
	private Race race;
	private ObjectiveSpriteWantedComponent oswc;
	private ObjectiveWorkerWantedComponent owwc;

	@Override
	public String getComponentName() {
		return ObjectiveWantedComponent.class.getName();
	}

	@Override
	public void initial(AgentContext context, StandardWorldModel world) {
		this.opc = (ObjectiveRaceComponent) context.getAntComponentKit().getAntComponent(ObjectiveRaceComponent.class);
		this.race = opc.getMyRace();
		if (race == Race.Sprite) {
			this.oswc = new ObjectiveSpriteWantedComponent();
			this.oswc.initial(context, world);
		} else {
			this.owwc = new ObjectiveWorkerWantedComponent();
			this.owwc.initial(context, world);
		}
	}

	@Override
	public void update() {
		if (race == Race.Sprite) {
			this.oswc.update();
		} else {
			this.owwc.update();
		}
	}
	
	public ObjectiveSpriteWantedComponent getObjectiveSpriteWantedComponent() {
		return oswc;
	}

	public ObjectiveWorkerWantedComponent getObjectiveWorkerWantedComponent() {
		return owwc;
	}
}
