package ant.component.pf.spot;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.universal.AgentLocationComponent.AgentLocationInfo;
import ant.utils.geo.GeoUtils;

/**
 * 
 * @author Ivan
 * just For Low-BandWidth
 */
public class SpotAgentSpawn extends AbstractSpot {
	private static final int MOVEOUT = 100000;
	private EntityID tarWhere;
	private EntityID tarAgent;

	public SpotAgentSpawn(AgentContext context, EntityID tarAgent, EntityID tarWhere) {
		super(context);
		this.tarAgent = tarAgent;
		this.tarWhere = tarWhere;
	}

	@Override
	public SpotType getType() {
		return SpotType.AgentSpawn;
	}

	@Override
	public EntityID getWhere() {
		return tarWhere;
	}

	public EntityID getAgentID() {
		return tarAgent;
	}
	
	@Override
	public void triggerUpdate() {
		if (this.isDone) return;
		
		for (Human h : pfset) {
			for (AgentLocationInfo ali : alc.getUpdatedAgentLocationInfos(h.getID())) {
				EntityID loc = ali.getLocation();
				if (tarWhere.equals(loc)) {
					this.done();
				}
			}
		}
		
		EntityID now = alc.getAgentLastLocation(tarAgent);
		if (GeoUtils.manhattanDistance((Area) world.getEntity(now), (Area) world.getEntity(tarWhere)) > MOVEOUT) {
			this.done();
		}
	}

}
