package ant.component.pf.spot;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.universal.AgentLocationComponent.AgentLocationInfo;

/**
 * 
 * @author Ivan
 *
 */
public class SpotBuildingExploration extends AbstractSpot {

	private Building tar;

	public SpotBuildingExploration(AgentContext context, Building b) {
		super(context);
		this.tar = b;
	}

	@Override
	public SpotType getType() {
		return SpotType.BuildingExploration;
	}

	@Override
	public void triggerUpdate() {
		// TODO more
		if (this.isDone) return;
		
		for (Human h : agentset) {
			for (AgentLocationInfo ali : alc.getUpdatedAgentLocationInfos(h.getID())) {
				EntityID loc = ali.getLocation();
				if (tar.getID().equals(loc)) {
					this.done();
				}
			}
		}
	}

	public Building getTargetBuilding() {
		return tar;
	}

	@Override
	public EntityID getWhere() {
		return tar.getID();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((tar == null) ? 0 : tar.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SpotBuildingExploration other = (SpotBuildingExploration) obj;
		if (tar == null) {
			if (other.tar != null)
				return false;
		} else if (!tar.equals(other.tar))
			return false;
		return true;
	}
	
	
}
