package ant.component.pf.spot;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.universal.AgentLocationComponent.AgentLocationInfo;
import ant.component.universal.BuildingConditionComponent;
import ant.component.universal.BuildingConditionComponent.BuildingCondition;

/**
 * 
 * @author Ivan
 * 
 */
public class SpotCivInBuilding extends AbstractSpot {

	private Building building;
	private EntityID civid;
	private BuildingConditionComponent bcc;

	public SpotCivInBuilding(AgentContext context, Building b, EntityID civid) {
		super(context);
		this.building = b;
		this.civid = civid;
		this.bcc = context.getAntComponentKit().getBuildingConditionComponent();
	}

	@Override
	public SpotType getType() {
		return SpotType.CivInBuilding;
	}

	@Override
	public void triggerUpdate() {
		if (this.isDone)
			return;

		for (Human h : agentset) {
			for (AgentLocationInfo ali : alc.getUpdatedAgentLocationInfos(h.getID())) {
				EntityID loc = ali.getLocation();
				if (building.getID().equals(loc)) {
					this.done();
				}
			}
		}

		BuildingCondition bc = bcc.getBuildingCondition(this.building.getID());
		if (bc.isOnFire())
			done();
	}

	@Override
	public EntityID getWhere() {
		return building.getID();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((building == null) ? 0 : building.hashCode());
		result = prime * result + ((civid == null) ? 0 : civid.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SpotCivInBuilding other = (SpotCivInBuilding) obj;
		if (building == null) {
			if (other.building != null)
				return false;
		} else if (!building.equals(other.building))
			return false;
		if (civid == null) {
			if (other.civid != null)
				return false;
		} else if (!civid.equals(other.civid))
			return false;
		return true;
	}

}
