package ant.component.pf.spot;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.Road;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.universal.AgentLocationComponent.AgentLocationInfo;

/**
 * 
 * @author Ivan
 * 
 */
public class SpotHighlyRoadArrive extends AbstractSpot {

	private Road r;

	public SpotHighlyRoadArrive(AgentContext context, Road r) {
		super(context);
		this.r = r;
	}

	@Override
	public SpotType getType() {
		return SpotType.HighlyRoadArrive;
	}

	@Override
	public void triggerUpdate() {
		// TODO more
		if (this.isDone)
			return;

		for (Human h : agentset) {
			for (AgentLocationInfo ali : alc.getUpdatedAgentLocationInfos(h.getID())) {
				EntityID loc = ali.getLocation();
				if (r.getID().equals(loc)) {
					this.done();
				}
			}
		}
	}

	@Override
	public EntityID getWhere() {
		return r.getID();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((r == null) ? 0 : r.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SpotHighlyRoadArrive other = (SpotHighlyRoadArrive) obj;
		if (r == null) {
			if (other.r != null)
				return false;
		} else if (!r.equals(other.r))
			return false;
		return true;
	}
	
	
}
