package ant.component.pf.spot;

import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.pf.ObjectiveMiscComponent;
import ant.component.universal.JamComponent.JamState;
import ant.exception.StatusInconsistentException;

/**
 * 
 * @author Ivan
 * 
 */

// TODO 有ActivePF经过就认为完成了, 以后可再也不要管了
public class SpotJamAgentBuried extends AbstractSpotJam {
	private static final Log log = LogFactory.getLog(SpotJamAgentBuried.class);
	
	private Set<Human> agset;
	private ObjectiveMiscComponent csc;

	public SpotJamAgentBuried(AgentContext context, EntityID who) throws StatusInconsistentException {
		super(context, who);
		this.csc = (ObjectiveMiscComponent) context.getAntComponentKit().getAntComponent(ObjectiveMiscComponent.class);
		this.agset = context.getAntComponentKit().getAntMapBasisComponent().getAgentSet();
	}

	@Override
	public SpotType getType() {
		return SpotType.AgentBuried;
	}

	@Override
	public void triggerUpdate() {
		if (this.isDone)
			return;

		// Case 1 if jam
		if (this.jam.getState() != JamState.Buried) {
			log.info("Buried :" + jam.getBuriedBuilding() + "is done, Agent:" + this.stuckAgent + " get out of");
 			this.done();
			return;
		}

		EntityID b = jam.getBuriedBuilding();
		
		// Case 2 if any active agent stay in the building
		if (csc.getActivePoliceForceVisitedBuildingSet().contains(b)) {
//			log.info("Buried :" + jam.getBuriedBuilding() + "is done, pf arrived");
			this.done();
			return;
		}

		// TODO AT/PF认为可以到,或通知已经做完了
	}

}
