package ant.component.pf.spot;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.universal.JamComponent.JamState;
import ant.exception.StatusInconsistentException;
import ant.map.jigsaw.JigsawAttach;

/**
 * 
 * @author Ivan
 * 
 */
public class SpotJamStuckInBuilding extends AbstractSpotJam {
	private static final Log log = LogFactory.getLog(SpotJamStuckInBuilding.class);

	private JigsawAttach tarJigsaw;

	public SpotJamStuckInBuilding(AgentContext context, EntityID stuckAgent) throws StatusInconsistentException {
		super(context, stuckAgent);
		this.tarJigsaw = (JigsawAttach) jimain.getJigsaw(jam.getStuckBuilding());
	}

	@Override
	public SpotType getType() {
		return SpotType.AgentStuckingInBuilding;
	}

	/** 检查是否有PF在refJigsaw(Only Building) 里面 **/
	@Override
	public void triggerUpdate() {
		if (this.isDone)
			return;

		// Case 1 得知此人离开了, JamComponent控制
		if (jam.getState() != JamState.StuckInBuilding) {
			this.done();
			return;
		}

		// Case 2 发现ActivePF到了Stuck的JigsawAttach(Only Building)里面
		for (Human h : pfset) {
			if (this.jc.getJam(h.getID()).getState() != JamState.Buried) {
				EntityID where = alc.getAgentLastLocation(h.getID());
				Area a = (Area) context.getWorld().getEntity(where);
				if (a instanceof Building) {
					if (tarJigsaw.contains(a)) {
						this.done();
						return;
					}
				}
			}
		}

		// TODO Case 3 某人说已经做完了
	}

}
