package ant.component.pf.spot;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.universal.ChangeSetDetailComponent;
import ant.component.universal.JamComponent.JamState;
import ant.exception.StatusInconsistentException;
import ant.utils.Pair;

/**
 * 
 * @author Ivan
 * 
 */
public class SpotJamStuckInRoad extends AbstractSpotJam {
	private static final Log log = LogFactory.getLog(SpotJamStuckInRoad.class);
	private int jid;
	private ChangeSetDetailComponent csd;

	public SpotJamStuckInRoad(AgentContext context, EntityID stuckAgent) throws StatusInconsistentException {
		super(context, stuckAgent);
		this.csd = context.getAntComponentKit().getChangeSetDetailComponent();
	}

	@Override
	public SpotType getType() {
		return SpotType.AgentStuckingInRoad;
	}

	@Override
	public void triggerUpdate() {
		if (this.isDone)
			return;

		// Case 1 得知此人离开了, JamComponent控制
		if (jam.getState() != JamState.StuckInRoad) {
			// log.info("StuckInRoad  " + stuckAgent + " get out");
			this.done();
			return;
		}
		
		// Case 2 Other PF 移动到了?

		// Case 3 其他PF通知说已经做完
	}

	public Pair<Integer, Integer> getStuckXY() {
		if (jam.getState() == JamState.StuckInRoad) {
			if (jam.getStuckRoodCoord() != null) {
				return new Pair<Integer, Integer>(jam.getStuckRoodCoord().getX(), jam.getStuckRoodCoord().getY());
			}
		}
		return null;
	}
	
	@Override
	public String toString() {
		return super.toString() + "JID:" + jid;
	}

//	public int getJid() {
//		return jid;
//	}
//
//	public void setJid(int jid) {
//		this.jid = jid;
//	}
	
}
