package ant.component.pf.spot;

import rescuecore2.standard.entities.Human;
import rescuecore2.worldmodel.EntityID;
import ant.AgentContext;
import ant.component.pf.ObjectiveJigsaw;
import ant.component.universal.JamComponent.JamState;

/**
 * 
 * @author Ivan
 *
 */
public class SpotSuperiorExploration extends AbstractSpot {

	private ObjectiveJigsaw oj;

	public SpotSuperiorExploration(AgentContext context, ObjectiveJigsaw oj) {
		super(context);
		this.oj = oj;
	}

	@Override
	public SpotType getType() {
		return SpotType.SuperiorExploration;
	}

	@Override
	public void triggerUpdate() {
		if (this.isDone)
			return;
		
		for (Human h : pfset) {
			if (this.jc.getJam(h.getID()).getState() != JamState.Buried) {
				EntityID where = alc.getAgentLastLocation(h.getID());
				if (oj.getJigsawObject().contains(where)) {
					this.done();
					return;
				}
			}
		}
	}

	@Override
	public EntityID getWhere() {
		return oj.getJigsawObject().getCenter().getID();
	}
	
	@Override
	public String toString() {
		return "SpotSuperiorExploration [oj=" + oj + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((oj == null) ? 0 : oj.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SpotSuperiorExploration other = (SpotSuperiorExploration) obj;
		if (oj == null) {
			if (other.oj != null)
				return false;
		} else if (!oj.equals(other.oj))
			return false;
		return true;
	}

	
}
