package ant.component.universal;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.StandardWorldModel;
import ant.AgentContext;
import ant.AntComponent;
import ant.utils.traffic.TrafficMove;
import ant.utils.traffic.TrafficStepSimulator;
import ant.utils.traffic.TrafficStepSimulator.TrafficSimRes;

public class TrafficStepSimComponent implements AntComponent {
	private static Log log = LogFactory.getLog(TrafficStepSimComponent.class);

	private TrafficStepSimulator simulator;
	private TrafficSimRes res = null;
	private AgentContext context;

	@Override
	public String getComponentName() {
		return "TrafficStepSimComponent";
	}

	@Override
	public void initial(AgentContext context, StandardWorldModel world) {
		simulator = new TrafficStepSimulator(context);
		this.context = context;
	}

	public void simulate(TrafficMove move) {
		res = this.simulator.simulate(move);
	}

	public TrafficSimRes getResult() {
		return res;
	}

	@Override
	public void update() {
		// simulator = new TrafficStepSimulator(context);
	}

}
