package ant.liaison;

import rescuecore2.standard.entities.Road;

/**
 * 
 * @author Ivan
 *
 */
public class RoadCoord {
	
	private int x;
	private int y;
	private Road road;

	public RoadCoord(Road r, int x, int y) {
		this.x = x;
		this.y = y;
		this.road = r;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public Road getRoad() {
		return road;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((road == null) ? 0 : road.hashCode());
		result = prime * result + x;
		result = prime * result + y;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RoadCoord other = (RoadCoord) obj;
		if (road == null) {
			if (other.road != null)
				return false;
		} else if (!road.equals(other.road))
			return false;
		if (x != other.x)
			return false;
		if (y != other.y)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "RoadCoord [x=" + x + ", y=" + y + ", road=" + road + "]";
	}
	
	
}
