package ant.liaison.channel;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import ant.liaison.channel.detect.ChannelConditionDetector;

/**
 * 
 * @author Oliver
 * 
 */
public class ChannelCondition {
	private static Log log = LogFactory.getLog(ChannelCondition.class);

	private int id;
	private int baseMsgSentNum;
	private int msgSentCount;
	private int msgReceivedCount;
	private int emptyMsgCount;

	public ChannelCondition(int id, int baseMsgSentNum) {
		this.id = id;
		this.baseMsgSentNum = baseMsgSentNum;
		this.msgSentCount = 0;
		this.msgReceivedCount = 0;
		this.emptyMsgCount = 0;
	}

	/**
	 * make sure that channels whose condition is detected will accelerate the
	 * msgSentCount
	 */
	public void ajustMsgSentCount() {
		msgSentCount = baseMsgSentNum;
	}

	public void receiveNewMsg(String content) {
		if (content.length() == 0) {
			// empty msg
			emptyMsgCount++;
		} else if (content.equals(ChannelConditionDetector.DETECT_MSG)) {
			msgReceivedCount++;
		}else{
			log.error("Unknown msg with content:" + content);
		}
	}

	public void updateCondition(int newReveiceCount) {
		msgSentCount += baseMsgSentNum;
		msgReceivedCount += newReveiceCount;
	}

	public int getId() {
		return id;
	}

	public int getBaseMsgSentNum() {
		return baseMsgSentNum;
	}

	public int getMsgSentCount() {
		return msgSentCount;
	}

	public int getMsgReceivedCount() {
		return msgReceivedCount;
	}

	public int getEmptyMsgCount() {
		return emptyMsgCount;
	}

	@Override
	public String toString() {
		return "ChannelCondition [id=" + id + ", baseMsgSentNum=" + baseMsgSentNum
				+ ", msgSentCount=" + msgSentCount + ", msgReceivedCount=" + msgReceivedCount
				+ ", emptyMsgCount=" + emptyMsgCount + "]";
	}
}