package ant.liaison.channel.assign;

import java.util.Comparator;

import ant.liaison.channel.RadioChannel;

/**
 * 
 * @author Oliver
 * 
 */
public class ChannelComparatorForAssign implements Comparator<RadioChannel> {
	private static final int DIFFER_TOLERANCE = 30;

	@Override
	public int compare(RadioChannel r1, RadioChannel r2) {
		double differ = -r1.getBandWidth() * r1.getSuccessRate() + r2.getBandWidth()
				* r2.getSuccessRate();
		if (differ > DIFFER_TOLERANCE) {
			return 1;
		} else if (differ < -DIFFER_TOLERANCE) {
			return -1;
		} else {
			return r1.getId() - r2.getId();
		}
	}
}