package ant.liaison.channel.io;

import java.util.Comparator;

/**
 * 
 * @author Oliver
 * 
 */
public class MessageInfoComparator implements Comparator<MessageInfo> {
	private static final double MIN_D_RECEIVE_RATE = 0.03d;

	@Override
	public int compare(MessageInfo m0, MessageInfo m1) {
		int dRepeateTime = m0.getRepeateTime() - m1.getRepeateTime();
		if (dRepeateTime != 0) {
			return dRepeateTime;
		}

		int dPriority = m0.getMessageType().getPriority() - m1.getMessageType().getPriority();
		if (dPriority != 0) {
			return dPriority;
		}

		double dReceiveRate = m0.getReceiveRate() - m1.getReceiveRate();
		if (dReceiveRate < -MIN_D_RECEIVE_RATE) {
			return -1;
		} else if (dReceiveRate > MIN_D_RECEIVE_RATE) {
			return 1;
		}

		int dLength = m0.getMsgContent().length - m1.getMsgContent().length;
		if (dLength != 0) {
			return dLength;
		}

		int dReceiverCount = m0.getMessageType().getReceivers().length
				- m1.getMessageType().getReceivers().length;
		return dReceiverCount;
	}
}
