package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;

/**
 * 
 * @author Ivan
 *
 */
public abstract class AbstractMessage implements IMessage {

	protected EntityID sender;
	protected int timestamp = -1;
	
	@Override
	public EntityID getSender() {
		return sender;
	}

	@Override
	public void setSender(EntityID id) {
		this.sender = id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((sender == null) ? 0 : sender.hashCode());
		result = prime * result + timestamp;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AbstractMessage other = (AbstractMessage) obj;
		if (sender == null) {
			if (other.sender != null) {
				return false;
			}
		} else if (!sender.equals(other.sender)) {
			return false;
		}
		if (timestamp != other.timestamp) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "Message [sender=" + sender + "]";
	}
	
	@Override
	public int getTimestamp() {
		return timestamp;
	}
	
	@Override
	public void setTimestamp(int timestamp) {
		this.timestamp = timestamp;
	}
	
	
}
