package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Oliver
 * 
 */
public class MAgentBuildingLocation extends AbstractMessage implements IAgentLocationMessage,
		IBuildingCivilianMessage, IBuildingFire {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.BuildingID)
	private EntityID location;

	@MessagePropertyDesc(order = 1, bind = MessageProperty.Boolean)
	private boolean isCivilianInBuilding;

	@MessagePropertyDesc(order = 2, bind = MessageProperty.Boolean)
	private boolean isBuildingOnFire;

	public MAgentBuildingLocation() {
	}

	public MAgentBuildingLocation(EntityID location, boolean civilianInBuilding,
			boolean isBuildingOnFire) {
		this.location = location;
		this.isCivilianInBuilding = civilianInBuilding;
		this.isBuildingOnFire = isBuildingOnFire;
	}

	public void setLocation(EntityID location) {
		this.location = location;
	}

	public EntityID getLocation() {
		return location;
	}

	public void setCivilianInBuilding(boolean civilianInBuilding) {
		this.isCivilianInBuilding = civilianInBuilding;
	}

	@Override
	public boolean isCivilianInBuilding() {
		return isCivilianInBuilding;
	}

	@Override
	public boolean isBuildingOnFire() {
		return isBuildingOnFire;
	}

	public void setBuildingOnFire(boolean isBuildingOnFire) {
		this.isBuildingOnFire = isBuildingOnFire;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.AgentBuildingLocation;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + (isCivilianInBuilding ? 1231 : 1237);
		result = prime * result + (isBuildingOnFire ? 1231 : 1237);
		result = prime * result + ((location == null) ? 0 : location.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		MAgentBuildingLocation other = (MAgentBuildingLocation) obj;
		if (isCivilianInBuilding != other.isCivilianInBuilding) {
			return false;
		}
		if (isBuildingOnFire != other.isBuildingOnFire) {
			return false;
		}
		if (location == null) {
			if (other.location != null) {
				return false;
			}
		} else if (!location.equals(other.location)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MAgentBuildingLocation [location=" + location
				+ ", civilianInBuilding=" + isCivilianInBuilding + ", isBuildingOnFire="
				+ isBuildingOnFire + "]";
	}

}