package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

public class MAgentBuried extends AbstractMessage implements IAgentLocationMessage,
		IBuildingCivilianMessage, IBuildingFire {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.Hp)
	private int hp;

	@MessagePropertyDesc(order = 1, bind = MessageProperty.Damage)
	private int damage;

	@MessagePropertyDesc(order = 2, bind = MessageProperty.Buriesness)
	private int buriedness;

	@MessagePropertyDesc(order = 3, bind = MessageProperty.BuildingID)
	private EntityID buriedBuilding;

	@MessagePropertyDesc(order = 4, bind = MessageProperty.Boolean)
	private boolean civilianInBuilding;

	@MessagePropertyDesc(order = 5, bind = MessageProperty.Boolean)
	private boolean isBuildingOnFire;

	public MAgentBuried() {
	}

	public MAgentBuried(int hp, int damage, int buriedness, EntityID buriedBuilding,
			boolean civInBuilding, boolean isBuildingOnFire) {
		this.hp = hp;
		this.damage = damage;
		this.buriedness = buriedness;
		this.buriedBuilding = buriedBuilding;
		this.civilianInBuilding = civInBuilding;
		this.isBuildingOnFire = isBuildingOnFire;
	}

	public int getHp() {
		return hp;
	}

	public void setHp(int hp) {
		this.hp = hp;
	}

	public int getDamage() {
		return damage;
	}

	public void setDamage(int damage) {
		this.damage = damage;
	}

	public int getBuriedness() {
		return buriedness;
	}

	public void setBuriedness(int buriedness) {
		this.buriedness = buriedness;
	}

	public EntityID getBuriedBuilding() {
		return buriedBuilding;
	}

	public void setBuriedBuilding(EntityID buriedBuilding) {
		this.buriedBuilding = buriedBuilding;
	}

	@Override
	public boolean isCivilianInBuilding() {
		return civilianInBuilding;
	}

	public void setCivilianInBuilding(boolean civilianInBuilding) {
		this.civilianInBuilding = civilianInBuilding;
	}

	@Override
	public EntityID getLocation() {
		return this.buriedBuilding;
	}

	@Override
	public boolean isBuildingOnFire() {
		return isBuildingOnFire;
	}

	public void setBuildingOnFire(boolean isBuildingOnFire) {
		this.isBuildingOnFire = isBuildingOnFire;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.AgentBuried;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MAgentBuried [hp=" + hp + ", damage=" + damage
				+ ", buriedness=" + buriedness + ", buriedBuilding=" + buriedBuilding
				+ ", civilianInBuilding=" + civilianInBuilding + ", isBuildingOnFire="
				+ isBuildingOnFire + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((buriedBuilding == null) ? 0 : buriedBuilding.hashCode());
		result = prime * result + buriedness;
		result = prime * result + (civilianInBuilding ? 1231 : 1237);
		result = prime * result + damage;
		result = prime * result + hp;
		result = prime * result + (isBuildingOnFire ? 1231 : 1237);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		MAgentBuried other = (MAgentBuried) obj;
		if (buriedBuilding == null) {
			if (other.buriedBuilding != null) {
				return false;
			}
		} else if (!buriedBuilding.equals(other.buriedBuilding)) {
			return false;
		}
		if (buriedness != other.buriedness) {
			return false;
		}
		if (civilianInBuilding != other.civilianInBuilding) {
			return false;
		}
		if (damage != other.damage) {
			return false;
		}
		if (hp != other.hp) {
			return false;
		}
		if (isBuildingOnFire != other.isBuildingOnFire) {
			return false;
		}
		return true;
	}
}
