package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Ivan
 * 
 */
public class MAgentLocation extends AbstractMessage implements IAgentLocationMessage {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.AreaID)
	private EntityID location;

	public MAgentLocation() {
	}

	public MAgentLocation(EntityID location) {
		this.location = location;
	}

	public void setLocation(EntityID location) {
		this.location = location;
	}

	public EntityID getLocation() {
		return location;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.AgentLocation;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((location == null) ? 0 : location.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MAgentLocation other = (MAgentLocation) obj;
		if (location == null) {
			if (other.location != null)
				return false;
		} else if (!location.equals(other.location))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MAgentLocation [sender=" + sender + ", location=" + location + "]";
	}

}
