package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Fun
 * 
 */
public class MAgentRescued extends AbstractMessage {
	@MessagePropertyDesc(order = 0, bind = MessageProperty.AgentID)
	private EntityID agent;

	public MAgentRescued() {
		super();
	}

	public MAgentRescued(EntityID agent) {
		super();
		this.agent = agent;
	}

	public EntityID getAgent() {
		return agent;
	}

	public void setAgent(EntityID agent) {
		this.agent = agent;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MAgentRescued [agent=" + agent + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((agent == null) ? 0 : agent.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MAgentRescued other = (MAgentRescued) obj;
		if (agent == null) {
			if (other.agent != null)
				return false;
		} else if (!agent.equals(other.agent))
			return false;
		return true;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.AgentRescued;
	}

}
