package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Oliver
 * 
 */
public class MAgentRoadLocation extends AbstractMessage implements IAgentLocationMessage {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.RoadID)
	private EntityID location;

	@MessagePropertyDesc(order = 1, bind = MessageProperty.Boolean)
	private boolean isFireSeenAround;

	@MessagePropertyDesc(order = 2, bind = MessageProperty.Boolean)
	private boolean isBlockadeSeenOnTheRoad;

	public MAgentRoadLocation() {
	}

	public MAgentRoadLocation(EntityID location, boolean isFireSeenAround,
			boolean isBlockadeSeenOnTheRoad) {
		this.location = location;
		this.isBlockadeSeenOnTheRoad = isFireSeenAround;
		this.isFireSeenAround = isBlockadeSeenOnTheRoad;
	}

	public void setLocation(EntityID location) {
		this.location = location;
	}

	public EntityID getLocation() {
		return location;
	}

	public void setFireSeenAround(boolean isFireSeenAround) {
		this.isFireSeenAround = isFireSeenAround;
	}

	public boolean isFireSeenAround() {
		return isFireSeenAround;
	}

	public boolean isBlockadeSeenOnTheRoad() {
		return isBlockadeSeenOnTheRoad;
	}

	public void setBlockadeSeenOnTheRoad(boolean isBlockadeSeenOnTheRoad) {
		this.isBlockadeSeenOnTheRoad = isBlockadeSeenOnTheRoad;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.AgentRoadLocation;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + (isBlockadeSeenOnTheRoad ? 1231 : 1237);
		result = prime * result + (isFireSeenAround ? 1231 : 1237);
		result = prime * result + ((location == null) ? 0 : location.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MAgentRoadLocation other = (MAgentRoadLocation) obj;
		if (isBlockadeSeenOnTheRoad != other.isBlockadeSeenOnTheRoad)
			return false;
		if (isFireSeenAround != other.isFireSeenAround)
			return false;
		if (location == null) {
			if (other.location != null)
				return false;
		} else if (!location.equals(other.location))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MAgentRoadLocation [sender=" + sender + ", location=" + location
				+ ", fireSeenAround=" + isFireSeenAround + ", blockadeSeenOnTheRoad="
				+ isBlockadeSeenOnTheRoad + "]";
	}
}
