package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Ivan
 *
 */
public class MBuildingBurning extends AbstractMessage {
	
	@MessagePropertyDesc(order = 0, bind = MessageProperty.BuildingID)
	private EntityID building;
	
	@MessagePropertyDesc(order = 1, bind = MessageProperty.Fieryness)
	private int fieryness;
	
	@MessagePropertyDesc(order = 2, bind = MessageProperty.Temperature)
	private int temperature;
	
	public MBuildingBurning() {
	}
	
	public MBuildingBurning(EntityID building, int fieryness, int temperature) {
		this.building = building;
		this.fieryness = fieryness;
		this.temperature = temperature;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.BuildingBurning;
	}

	public EntityID getBuilding() {
		return building;
	}

	public void setBuilding(EntityID building) {
		this.building = building;
	}

	public int getFieryness() {
		return fieryness;
	}

	public void setFieryness(int fieryness) {
		this.fieryness = fieryness;
	}

	public int getTemperature() {
		return temperature;
	}

	public void setTemperature(int temperature) {
		this.temperature = temperature;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((building == null) ? 0 : building.hashCode());
		result = prime * result + fieryness;
		result = prime * result + temperature;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		MBuildingBurning other = (MBuildingBurning) obj;
		if (building == null) {
			if (other.building != null)
				return false;
		} else if (!building.equals(other.building))
			return false;
		if (fieryness != other.fieryness)
			return false;
		if (temperature != other.temperature)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MBuildingBurning [sender=" + sender + ", building=" + building + ", fieryness="
				+ fieryness + ", temperature=" + temperature + "]";
	}

}
