package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

public class MBuildingCivilian extends AbstractMessage implements IBuildingCivilianMessage {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.BuildingID)
	private EntityID location;

	public MBuildingCivilian() {
	}

	public MBuildingCivilian(EntityID location, boolean civilianInBuilding) {
		this.location = location;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.BuildingCivilian;
	}

	@Override
	public boolean isCivilianInBuilding() {
		return false;
	}

	@Override
	public EntityID getLocation() {
		return location;
	}

	public void setLocation(EntityID location) {
		this.location = location;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((location == null) ? 0 : location.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		MBuildingCivilian other = (MBuildingCivilian) obj;
		if (location == null) {
			if (other.location != null) {
				return false;
			}
		} else if (!location.equals(other.location)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "MBuildingCivilian [location=" + location + "]";
	}
}
