package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Ivan
 *
 */
public class MFindCivilianInBuilding extends AbstractMessage {
	
	@MessagePropertyDesc(order = 0, bind = MessageProperty.CivilianID)
	private EntityID id;
	
	@MessagePropertyDesc(order = 1, bind = MessageProperty.BuildingID)
	private EntityID position;

	@MessagePropertyDesc(order = 2, bind = MessageProperty.Hp)
	private int hp;

	@MessagePropertyDesc(order = 3, bind = MessageProperty.Damage)
	private int damage;

	@MessagePropertyDesc(order = 4, bind = MessageProperty.Buriesness)
	private int buriedness;
	
	public MFindCivilianInBuilding() {
	}
	
	public MFindCivilianInBuilding(EntityID id, EntityID buildingPosition, int hp, int damage, int buriedness) {
		this.id = id;
		this.position = buildingPosition;
		this.hp = hp;
		this.damage = damage;
		this.buriedness = buriedness;
	}
	
	public EntityID getId() {
		return id;
	}

	public void setId(EntityID id) {
		this.id = id;
	}

	public EntityID getPosition() {
		return position;
	}

	public void setPosition(EntityID position) {
		this.position = position;
	}

	public int getHp() {
		return hp;
	}

	public void setHp(int hp) {
		this.hp = hp;
	}

	public int getDamage() {
		return damage;
	}

	public void setDamage(int damage) {
		this.damage = damage;
	}

	public int getBuriedness() {
		return buriedness;
	}

	public void setBuriedness(int buriedness) {
		this.buriedness = buriedness;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + buriedness;
		result = prime * result + damage;
		result = prime * result + hp;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((position == null) ? 0 : position.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		MFindCivilianInBuilding other = (MFindCivilianInBuilding) obj;
		if (buriedness != other.buriedness)
			return false;
		if (damage != other.damage)
			return false;
		if (hp != other.hp)
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (position == null) {
			if (other.position != null)
				return false;
		} else if (!position.equals(other.position))
			return false;
		return true;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.FindCivilianInBuilding;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MFindCivilian [sender=" + sender + ", id=" + id + ", position=" + position
				+ ", hp=" + hp + ", damage=" + damage + ", buriedness=" + buriedness + "]";
	}
}
