package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Fun
 * 
 */
public class MRescueNextOrder extends AbstractMessage {
	@MessagePropertyDesc(order = 0, bind = MessageProperty.AgentID)
	private EntityID ambulanceTeam;
	@MessagePropertyDesc(order = 1, bind = MessageProperty.CivilianID)
	private EntityID civilian;
	@MessagePropertyDesc(order = 2, bind = MessageProperty.BuildingID)
	private EntityID loaction;

	public MRescueNextOrder() {
		super();
	}

	public MRescueNextOrder(EntityID ambulanceTeam, EntityID civilian,
			EntityID loaction) {
		super();
		this.ambulanceTeam = ambulanceTeam;
		this.civilian = civilian;
		this.loaction = loaction;
	}

	public EntityID getAmbulanceTeam() {
		return ambulanceTeam;
	}

	public void setAmbulanceTeam(EntityID ambulanceTeam) {
		this.ambulanceTeam = ambulanceTeam;
	}

	public EntityID getCivilian() {
		return civilian;
	}

	public void setCivilian(EntityID civilian) {
		this.civilian = civilian;
	}

	public EntityID getLoaction() {
		return loaction;
	}

	public void setLoaction(EntityID loaction) {
		this.loaction = loaction;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result
				+ ((ambulanceTeam == null) ? 0 : ambulanceTeam.hashCode());
		result = prime * result
				+ ((civilian == null) ? 0 : civilian.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MRescueNextOrder other = (MRescueNextOrder) obj;
		if (ambulanceTeam == null) {
			if (other.ambulanceTeam != null)
				return false;
		} else if (!ambulanceTeam.equals(other.ambulanceTeam))
			return false;
		if (civilian == null) {
			if (other.civilian != null)
				return false;
		} else if (!civilian.equals(other.civilian))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MRescueNextOrder [ambulanceTeam=" + ambulanceTeam
				+ ", civilian=" + civilian + "]";
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.RescueNextOrder;
	}

}
