package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

public class MRescueOrderUnreachable extends AbstractMessage {
	@MessagePropertyDesc(order = 0, bind = MessageProperty.BuildingID)
	private EntityID loaction;
	
	public MRescueOrderUnreachable() {
		super();
	}

	public MRescueOrderUnreachable(EntityID loaction) {
		super();
		this.loaction = loaction;
	}

	public EntityID getLoaction() {
		return loaction;
	}

	public void setLoaction(EntityID loaction) {
		this.loaction = loaction;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((loaction == null) ? 0 : loaction.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MRescueOrderUnreachable other = (MRescueOrderUnreachable) obj;
		if (loaction == null) {
			if (other.loaction != null)
				return false;
		} else if (!loaction.equals(other.loaction))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "MRescueOrderUnreachable [loaction=" + loaction + "]";
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.RescueOrderUnreachable;
	}
}
