package ant.liaison.message;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Road;
import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;
import ant.liaison.RoadCoord;

/**
 * 
 * @author Ivan
 * 
 */
public class MStuckInRoad extends AbstractMessage implements IMessage, IAgentLocationMessage {
	private static Log log = LogFactory.getLog(MStuckInRoad.class);

	@MessagePropertyDesc(order = 0, bind = MessageProperty.RoadCoord)
	private RoadCoord roadCoord;

	public MStuckInRoad() {
	}

	public MStuckInRoad(RoadCoord roadCoord) {
		this.roadCoord = roadCoord;
	}

	public MStuckInRoad(Road r, int x, int y) {
		this.roadCoord = new RoadCoord(r, x, y);
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.StuckInRoad;
	}

	public RoadCoord getRoadCoord() {
		return roadCoord;
	}

	public void setRoadCoord(RoadCoord roadCoord) {
		this.roadCoord = roadCoord;
	}

	@Override
	public EntityID getLocation() {
		if (roadCoord == null) {
			log.error("roadCoord:" + roadCoord);
			return null;
		}
		return roadCoord.getRoad().getID();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((roadCoord == null) ? 0 : roadCoord.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MStuckInRoad other = (MStuckInRoad) obj;
		if (roadCoord == null) {
			if (other.roadCoord != null)
				return false;
		} else if (!roadCoord.equals(other.roadCoord))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MAgentBlockInRoad [roadCoord=" + roadCoord + "]";
	}

}
