package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

public class MTargeBuildingUnreachable extends AbstractMessage {
	@MessagePropertyDesc(order = 0, bind = MessageProperty.BuildingID)
	private EntityID target;

	public MTargeBuildingUnreachable() {
	}
	
	public MTargeBuildingUnreachable(EntityID target) {
		this.target = target;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.TargeBuildingUnreachable;
	}

	public EntityID getTarget() {
		return target;
	}

	public void setTarget(EntityID target) {
		this.target = target;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((target == null) ? 0 : target.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MTargeBuildingUnreachable other = (MTargeBuildingUnreachable) obj;
		if (target == null) {
			if (other.target != null)
				return false;
		} else if (!target.equals(other.target))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MTargeBuildingUnreachable [target=" + target + "]";
	}
	
	
}
