package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Ivan, Oliver, Fun
 * 
 */

public class MVoiceAgentBuried extends AbstractMessage implements IAgentLocationMessage, IWho,
		IBuildingCivilianMessage, IBuildingFire, IVoiceAgentBuried {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.Hp)
	private int hp;

	@MessagePropertyDesc(order = 1, bind = MessageProperty.Damage)
	private int damage;

	@MessagePropertyDesc(order = 2, bind = MessageProperty.Buriesness)
	private int buriedness;

	@MessagePropertyDesc(order = 3, bind = MessageProperty.AgentID)
	private EntityID agent;

	@MessagePropertyDesc(order = 4, bind = MessageProperty.BuildingID)
	private EntityID building;

	@MessagePropertyDesc(order = 5, bind = MessageProperty.Boolean)
	private boolean isCivilianInBuilding;

	@MessagePropertyDesc(order = 6, bind = MessageProperty.Boolean)
	private boolean isBuildingOnFire;

	public MVoiceAgentBuried() {
	}

	public MVoiceAgentBuried(int hp, int damage, int buriedness,
			EntityID agent, EntityID building, boolean isCivilianInBuilding,
			boolean isBuildingOnFire) {
		super();
		this.hp = hp;
		this.damage = damage;
		this.buriedness = buriedness;
		this.agent = agent;
		this.building = building;
		this.isCivilianInBuilding = isCivilianInBuilding;
		this.isBuildingOnFire = isBuildingOnFire;
	}

	public int getHp() {
		return hp;
	}

	public void setHp(int hp) {
		this.hp = hp;
	}

	public int getDamage() {
		return damage;
	}

	public void setDamage(int damage) {
		this.damage = damage;
	}

	public int getBuriedness() {
		return buriedness;
	}

	public void setBuriedness(int buriedness) {
		this.buriedness = buriedness;
	}
	
	public EntityID getAgent() {
		return agent;
	}

	public void setAgent(EntityID agent) {
		this.agent = agent;
	}

	@Override
	public EntityID getWho() {
		return agent;
	}

	public void setWho(EntityID who) {
		this.agent = who;
	}

	public EntityID getBuilding() {
		return building;
	}

	public void setBuilding(EntityID building) {
		this.building = building;
	}

	@Override
	public EntityID getLocation() {
		return building;
	}

	@Override
	public boolean isCivilianInBuilding() {
		return isCivilianInBuilding;
	}

	public void setCivilianInBuilding(boolean isCivilianInBuilding) {
		this.isCivilianInBuilding = isCivilianInBuilding;
	}

	@Override
	public boolean isBuildingOnFire() {
		return isBuildingOnFire;
	}

	public void setBuildingOnFire(boolean isBuildingOnFire) {
		this.isBuildingOnFire = isBuildingOnFire;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.VoiceAgentBuried;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((agent == null) ? 0 : agent.hashCode());
		result = prime * result
				+ ((building == null) ? 0 : building.hashCode());
		result = prime * result + buriedness;
		result = prime * result + damage;
		result = prime * result + hp;
		result = prime * result + (isBuildingOnFire ? 1231 : 1237);
		result = prime * result + (isCivilianInBuilding ? 1231 : 1237);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MVoiceAgentBuried other = (MVoiceAgentBuried) obj;
		if (agent == null) {
			if (other.agent != null)
				return false;
		} else if (!agent.equals(other.agent))
			return false;
		if (building == null) {
			if (other.building != null)
				return false;
		} else if (!building.equals(other.building))
			return false;
		if (buriedness != other.buriedness)
			return false;
		if (damage != other.damage)
			return false;
		if (hp != other.hp)
			return false;
		if (isBuildingOnFire != other.isBuildingOnFire)
			return false;
		if (isCivilianInBuilding != other.isCivilianInBuilding)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "MVoiceAgentBuried [hp=" + hp + ", damage=" + damage
				+ ", buriedness=" + buriedness + ", agent=" + agent
				+ ", building=" + building + ", isCivilianInBuilding="
				+ isCivilianInBuilding + ", isBuildingOnFire="
				+ isBuildingOnFire + "]";
	}
}
