package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Ivan
 * 
 */
public class MVoiceAgentStuckInBuilding extends AbstractMessage implements IWho {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.AgentID)
	private EntityID who;

	@MessagePropertyDesc(order = 1, bind = MessageProperty.BuildingID)
	private EntityID building;

	public MVoiceAgentStuckInBuilding() {
	}

	public MVoiceAgentStuckInBuilding(EntityID who, EntityID building) {
		this.building = building;
		this.who = who;
	}

	@Override
	public EntityID getWho() {
		return who;
	}

	public void setWho(EntityID who) {
		this.who = who;
	}

	public EntityID getBuilding() {
		return building;
	}

	public void setBuilding(EntityID building) {
		this.building = building;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.VoiceAgentStuckInBuilding;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((building == null) ? 0 : building.hashCode());
		result = prime * result + ((who == null) ? 0 : who.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MVoiceAgentStuckInBuilding other = (MVoiceAgentStuckInBuilding) obj;
		if (building == null) {
			if (other.building != null)
				return false;
		} else if (!building.equals(other.building))
			return false;
		if (who == null) {
			if (other.who != null)
				return false;
		} else if (!who.equals(other.who))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " MVoiceAgentStuckInBuilding [who=" + who + ", building=" + building + "]";
	}

}
