package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Oliver
 * 
 */
public class MVoiceConfirmBuilding extends AbstractMessage {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.BuildingID)
	private EntityID building;

	@MessagePropertyDesc(order = 1, bind = MessageProperty.AreaID)
	private EntityID position;

	public MVoiceConfirmBuilding() {
	}

	public MVoiceConfirmBuilding(EntityID building, EntityID position) {
		this.building = building;
		this.position = position;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.VoiceConfirmBuilding;
	}

	public EntityID getBuilding() {
		return building;
	}

	public void setBuilding(EntityID building) {
		this.building = building;
	}

	public EntityID getPosition() {
		return position;
	}

	public void setPosition(EntityID position) {
		this.position = position;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((building == null) ? 0 : building.hashCode());
		result = prime * result + ((position == null) ? 0 : position.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		MVoiceConfirmBuilding other = (MVoiceConfirmBuilding) obj;
		if (building == null) {
			if (other.building != null) {
				return false;
			}
		} else if (!building.equals(other.building)) {
			return false;
		}
		if (position == null) {
			if (other.position != null) {
				return false;
			}
		} else if (!position.equals(other.position)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MVoiceConfirmBuilding [building=" + building
				+ ", position=" + position + ", sender=" + sender + "]";
	}
}
