package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Ivan
 *
 */
public class MVoiceGoingToBuilding extends AbstractMessage {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.BuildingID)
	private EntityID building;
	
	public MVoiceGoingToBuilding() {
	}
	
	public MVoiceGoingToBuilding(EntityID building) {
		this.building = building;
	}
	
	public EntityID getBuilding() {
		return building;
	}

	public void setBuilding(EntityID building) {
		this.building = building;
	}

	@Override
	public MessageType getMessageType() {
		return MessageType.VoiceGoingToBuilding;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((building == null) ? 0 : building.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MVoiceGoingToBuilding other = (MVoiceGoingToBuilding) obj;
		if (building == null) {
			if (other.building != null)
				return false;
		} else if (!building.equals(other.building))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "MVoiceGoingToBuilding [building=" + building + "]";
	}
	
}
