package ant.liaison.message;

import rescuecore2.worldmodel.EntityID;
import ant.liaison.MessageProperty;
import ant.liaison.MessagePropertyDesc;
import ant.liaison.MessageType;

/**
 * 
 * @author Ivan
 * 
 */
public class MZ_DeprecatedPoliceForceRefugeAcception extends AbstractMessage {

	@MessagePropertyDesc(order = 0, bind = MessageProperty.RefugeID)
	private EntityID targetRefuge;

	@Override
	public MessageType getMessageType() {
		return MessageType.PFRefugeAcception;
	}

	public MZ_DeprecatedPoliceForceRefugeAcception() {
	}

	public MZ_DeprecatedPoliceForceRefugeAcception(EntityID targetRefuge) {
		this.targetRefuge = targetRefuge;
	}

	public EntityID getTargetRefuge() {
		return targetRefuge;
	}

	public void setTargetRefuge(EntityID targetRefuge) {
		this.targetRefuge = targetRefuge;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((targetRefuge == null) ? 0 : targetRefuge.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		MZ_DeprecatedPoliceForceRefugeAcception other = (MZ_DeprecatedPoliceForceRefugeAcception) obj;
		if (targetRefuge == null) {
			if (other.targetRefuge != null)
				return false;
		} else if (!targetRefuge.equals(other.targetRefuge))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "#" + timestamp + " " + "MPFRefugeAcception [targetRefuge=" + targetRefuge + "]";
	}

}
