package ant.map.jigsaw;

import java.util.HashSet;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Road;

/**
 * 
 * @author Ivan
 *
 */
public class JigsawAvenue extends JigsawObject {
	private static final Log log = LogFactory.getLog(JigsawAvenue.class);
	
	private Set<JigsawCross> crosses;
	
	public JigsawAvenue(int jigsawID, Set<Area> raw) {
		super(jigsawID, raw);
		
		crosses = new HashSet<JigsawCross>();
		
		for (Area a : raw) {
			if (a instanceof Road) {
			} else {
				log.error("Bad avenue set");
			}
		}
	}

	@Override
	public JigsawType getType() {
		return JigsawType.Avenue;
	}
	
	@Override
	public void addAttach(JigsawAttach attach) {
		super.addAttach(attach);
	}
	
	public void addCross(JigsawCross jc) {
		crosses.add(jc);
	}
	
	public Set<JigsawCross> getCrosses() {
		return crosses;
	}
	
	@Override
	public String toString() {
		return "[JA " + rawAreaIDs + "]";
	}
	
}
