package ant.map.jigsaw;

import java.util.HashSet;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Road;

/**
 * 
 * @author Ivan
 * 
 */
public class JigsawCross extends JigsawObject {
	private static final Log log = LogFactory.getLog(JigsawCross.class);
	
	private Set<JigsawAvenue> avenues;
	
	public JigsawCross(int jigsawID, Set<Area> raw) {
		super(jigsawID, raw);
		this.avenues = new HashSet<JigsawAvenue>();
		
		for (Area a : raw) {
			if (a instanceof Road) {
			} else {
				log.error("Bad input set");
			}
		}
	}
	
	@Override
	public JigsawType getType() {
		return JigsawType.Cross;
	}
	
	@Override
	public void addAttach(JigsawAttach attach) {
		super.addAttach(attach);
	}
	
	public void addAvenue(JigsawAvenue ja) {
		this.avenues.add(ja);
	}
	
	public Set<JigsawAvenue> getAvenues() {
		return avenues;
	}
	
	@Override
	public String toString() {
		return "[JC " + rawAreaIDs + "]";
	}
	
	public JigsawAvenue getAvenueToOtherJigsawCross(JigsawCross other) {
		for (JigsawAvenue ja : this.avenues) {
			if (ja.getCrosses().contains(other)) {
				return ja;
			}
		}
		return null;
	}
}
