package ant.map.objects;

import java.util.Collection;
import java.util.Set;



/**
 * simply connected graph
 * 
 * @author Ivan
 */
public interface IGraph<V, E extends IGraphEdge<V>> {

	/**
	 * if not contains edge, return null
	 */
	public E getEdge(V source, V target);

	public void setEdge(V source, V target, E edge);

	public void addVertex(V v);

	public boolean containsEdge(V source, V target);

	public boolean containsVertex(V v);

	public Set<V> getVertexSet();

	/**
	 * directed graph. if undirected, you may remove(s, t), remove(t, s)
	 */
	public void removeEdge(V source, V target);

	public Set<V> getNeighbours(V v);

	/**
	 * @return outgoing edge
	 */
	public Collection<E> edgesOf(V v);
	
	// public Set<E> getAllEdges(V source, V target);

	// public Set<E> getEdgeSet();
	
	// public void removeVertex(V v);

	// public double getEdgeWeight(E e);

	// public Double getEdgeWeight(V source, V target);

	// public void addEdge(V source, V target, double weight);
	
	// public void addEdge(V source, V target, E e);
}
