package ant.map.objects;

import rescuecore2.standard.entities.Area;
import rescuecore2.worldmodel.EntityID;
import ant.utils.IPositioning;
import ant.utils.LabeledObject;

/**
 * 
 * @author Ivan
 *
 */
public class LabeledArea implements LabeledObject, IPositioning {

	private Area area;
	private int label;

	public LabeledArea(Area area, int label) {
		this.area = area;
		this.label = label;
	}
	
	@Override
	public int getLabel() {
		return this.label;
	}
	
	public Area getArea() {
		return area;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + label;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		LabeledArea other = (LabeledArea) obj;
		if (label != other.label)
			return false;
		return true;
	}

	@Override
	public int getX() {
		return area.getX();
	}

	@Override
	public int getY() {
		return area.getY();
	}
	
	public EntityID getID() {
		return area.getID();
	}

	@Override
	public String toString() {
		return "LabeledArea [area=" + area + ", label=" + label + "]";
	}
	
}
