package ant.map.objects;

import java.util.List;

/**
 * 
 * @author Ivan
 *
 * @param <V>
 */
public class Route<V> {
	protected V from;
	protected V to;
	protected List<V> route;
	protected double distance;

	public Route() {
	}

	public V getFrom() {
		return from;
	}

	public void setFrom(V from) {
		this.from = from;
	}

	public V getTo() {
		return to;
	}

	public void setTo(V to) {
		this.to = to;
	}
	
	/**
	 * @return route contains from & to
	 */
	public List<V> getRoute() {
		return route;
	}

	public void setRoute(List<V> route) {
		this.route = route;
	}

	public double getDistance() {
		return distance;
	}

	public void setDistance(double distance) {
		this.distance = distance;
	}

	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((from == null) ? 0 : from.hashCode());
		result = prime * result + ((route == null) ? 0 : route.hashCode());
		result = prime * result + ((to == null) ? 0 : to.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Route other = (Route) obj;
		if (from == null) {
			if (other.from != null)
				return false;
		} else if (!from.equals(other.from))
			return false;
		if (route == null) {
			if (other.route != null)
				return false;
		} else if (!route.equals(other.route))
			return false;
		if (to == null) {
			if (other.to != null)
				return false;
		} else if (!to.equals(other.to))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Route [distance=" + distance + ", from=" + from + ", to=" + to + ", route="
				+ route + "]";
	}
	
	public String toDebugString() {
		StringBuffer sb = new StringBuffer();
		sb.append("Route [distance=" + distance + ", from=" + from + ", to=" + to);
		sb.append("\n");
		for (V v : this.route) {
			sb.append(v);
			sb.append("\n");
		}
		return sb.toString();
	}
}
