package ant.map.partition;

import rescuecore2.standard.entities.Area;
import ant.utils.IPositioning;
import ant.utils.geo.GeoUtils;

/**
 * 
 * @author Ivan
 * 
 */
public class PartitionCluster implements IPositioning {
	protected int x, y, count;
	private long xsum, ysum;
	protected int id;

	public PartitionCluster(int id) {
		this.id = id;
		x = y = count = 0;
		xsum = ysum = 0;
	}

	public void addArea(Area a) {
		xsum += a.getX();
		ysum += a.getY();
		count += 1;
	}

	public void clear() {
		xsum = ysum = count = 0;
	}

	@Override
	public int getX() {
		return x;
	}

	@Override
	public int getY() {
		return y;
	}

	public int count() {
		return count;
	}

	public int getID() {
		return id;
	}

	public void setID(int id) {
		this.id = id;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public double convCalc() {
		int tempx = x;
		int tempy = y;
		if (this.count == 0) {
			this.count = 0;
			this.xsum = this.ysum = 0;
			return 0;
		} else {
			x = (int) (xsum / count);
			y = (int) (ysum / count);
		}
		
		this.count = 0;
		this.xsum = this.ysum = 0;
		return GeoUtils.manhattanDistance(tempx, tempy, x, y);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PartitionCluster other = (PartitionCluster) obj;
		if (id != other.id)
			return false;
		return true;
	}

}
