package ant.map.partition;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Area;
import ant.AgentContext;
import ant.map.component.AntMapBasisComponent;
import ant.utils.RandomSelector;
import ant.utils.geo.GeoUtils;

/**
 * 
 * @author Ivan
 * 
 * @depend {@link AntMapBasisComponent}
 */
@Deprecated
public class SimplePartitionAlgorithm extends AbstractPartitionAlgorithm {
	private static final Log log = LogFactory.getLog(SimplePartitionAlgorithm.class);

	private static final double CONV_DISTANCE = 1000;

	private int count = -1;
	private Set<Area> areaset;
	private Set<PartitionCluster> pcs;
	private Map<Integer, Partition> partmap;
	private ArrayList<Partition> parts;
	
	public SimplePartitionAlgorithm(AgentContext context, int partitionCount) {
		super(context);
		this.count = partitionCount;
		this.partmap = new HashMap<Integer, Partition>();
		this.parts = new ArrayList<Partition>();
	}

	@Override
	public int getPartitionCount() {
		return count;
	}

	@Override
	public ArrayList<Partition> getPartitions() {
		return parts;
	}

	@Override
	public void partition() {
		areaset = this.context.getAntComponentKit().getAntMapBasisComponent().getAreaSet();
		pcs = new HashSet<PartitionCluster>();
		
		Set<Area> inits = RandomSelector.randomSelect(areaset, count, context.getUniformRandom());
		int id = 0;
		for (Area b : inits) {
			PartitionCluster pc = new PartitionCluster(id);
			pc.addArea(b);
			pc.convCalc();
			partmap.put(id, new Partition(id));
			id++;
			pcs.add(pc);
		}
		
		int repeat = 0;
		while (true) {
			boolean conv = true;
			repeat++;
			for (Area a : areaset) {
				double min = Double.MAX_VALUE;
				PartitionCluster pick = null;
				for (PartitionCluster pc : pcs) {
					double temp = GeoUtils.manhattanDistance(pc, a);
					if (temp < min) {
						pick = pc;
						min = temp;
					}
				}
				pick.addArea(a);
			}
			
			for (PartitionCluster pc : pcs) {
				conv = conv && (pc.convCalc() <= CONV_DISTANCE);
			}
			
			if (repeat != 1 && conv) break;
		}
		
		log.info("Repeat: " + repeat);
		
		for (Area area : areaset) {
			double min = Double.MAX_VALUE;
			PartitionCluster pick = null;
			for (PartitionCluster pc : pcs) {
				double temp = GeoUtils.manhattanDistance(pc, area);
				if (temp < min) {
					pick = pc;
					min = temp;
				}
			}
			this.partmap.get(pick.getID()).addArea(area);
		}
		
		for (int i = 0; i < count; i++) {
			Partition p = this.partmap.get(i);
			p.convCalc();
			this.parts.add(p);
		}
	}

}
