package ant.map.search;

import ant.map.objects.IGraph;
import ant.map.objects.IGraphEdge;
import ant.map.objects.Route;

/**
 * 
 * @author Ivan
 *
 * @param <V>
 * @param <E>
 */
public abstract class AbstractShortestPathAlgorithm<V, E extends IGraphEdge<V>> {

	protected IGraph<V, E> graph = null;
	
	public AbstractShortestPathAlgorithm(IGraph<V, E> graph) {
		this.graph = graph;
	}
	
	/**
	 * @return null, if no path
	 */
	public abstract Route<V> spSearch(V source, V target);
	
	public abstract AbstractSSSPTree<V> ssspSearch(V source);

}