package ant.map.search.astar;

import ant.map.objects.IGraphEdge;

/**
 * 
 * @author Ivan
 *
 */
public class AStarGraphEdge implements IGraphEdge<AStarGraphNode> {
	private AStarGraphNode source;
	private AStarGraphNode target;
	private double weight;
	private double visibility;
	
	public AStarGraphEdge(AStarGraphNode source, AStarGraphNode target) {
		this.source = source;
		this.target = target;
	}
	
	public AStarGraphEdge(AStarGraphNode source, AStarGraphNode target, double weight) {
		this.source = source;
		this.target = target;
		this.weight = weight;
	}
	
	@Override
	public AStarGraphNode getSource() {
		return this.source;
	}

	@Override
	public AStarGraphNode getTarget() {
		return this.target;
	}

	public void setWeight(double weight) {
		this.weight = weight;
	}
	
	@Override
	public double getWeight() {
		return this.weight;
	}

	public double getVisibility() {
		return visibility;
	}
	
	public void setVisibility(double visibility) {
		this.visibility = visibility;
	}

	@Override
	public String toString() {
		return "AStarGraphEdge [source=" + source + ", target=" + target + ", visibility="
				+ visibility + ", weight=" + weight + "]";
	}
	
	
}
