package ant.map.search.astar;

import rescuecore2.standard.entities.Area;
import ant.utils.geo.Point;

/**
 * 
 * @author Ivan
 * 
 */
public abstract class AbstractAStarFunction {

	public abstract double heuristic(AStarGraphNode source, AStarGraphNode end);

	public final double heristric(AStarGraphNode source, Area end) {
		Point p = new Point(end.getX(), end.getY());
		return heristric(source, end, p);
	}

	public abstract double heristric(AStarGraphNode source, Area end, Point endPoint);

	// /** in same **/
	// public abstract double cost(RoadSide edge1, RoadSide edge2);
	//
	// /** nei cost */
	// public abstract double cost(RoadSide edge, Building b);
	//
	// public abstract double cost(Building b1, Building b2);

	/** move accept, source in end */
	public abstract boolean accept(AStarGraphNode source, Area end, Point point);
	
	public abstract boolean finish(AStarGraphNode source, Area end, Point point);
	
	/** end cost */
	public abstract double costEnd(AStarGraphNode source, Area end, Point endPoint);

	/** start center - edge */
	public final double costStart(AStarGraphNode source, Area end) {
		Point p = new Point(end.getX(), end.getY());
		return costStart(source, end, p);
	}

	/** start cost **/
	public abstract double costStart(AStarGraphNode source, Area end, Point endPoint);

	/** graph adjacent */
	public abstract double initialCost(AStarGraphNode n1, AStarGraphNode n2);

	public double initialVisibility(AStarGraphNode source, AStarGraphNode target) {
		return 1;
	}
	
	
	/**
	 * EE - SE <br>
	 * B - SE <br>
	 * 
	 * B - B <br>
	 * SE - SE <br>
	 * SE - B <br>
	 * SE - EE <br>
	 * EE - EE <br>
	 */
	/*
	 * public final double cost(AStarGraphNode n1, AStarGraphNode n2) {
	 * InnerType t1 = n1.getType(); InnerType t2 = n2.getType();
	 * 
	 * if (t1 == InnerType.SidePair && t2 == InnerType.Side) return cost(n2,
	 * n1);
	 * 
	 * if (t1 == InnerType.Building && t2 == InnerType.Side) return cost(n2,
	 * n1);
	 * 
	 * 
	 * if (t1 == InnerType.Building && t2 == InnerType.Building) { return
	 * cost(n1.getBuilding(), n2.getBuilding()); }
	 * 
	 * if (t1 == InnerType.Side && t2 == InnerType.Side) { if
	 * (n1.getSingleSide().getRoad().getID().getValue() !=
	 * n2.getSingleSide().getRoad().getID().getValue()) { throw new
	 * IllegalArgumentException("n1, n2 not in same road"); } else { return
	 * cost(n1.getSingleSide(), n2.getSingleSide()); } }
	 * 
	 * if (t1 == InnerType.Side && t2 == InnerType.Building) { if
	 * (!n1.getSingleSide
	 * ().getEdge().getNeighbour().equals(n2.getBuilding().getID())) { throw new
	 * IllegalArgumentException("n1, n2 are not adjacent"); } else { return
	 * cost(n1.getSingleSide(), n2.getBuilding()); } }
	 * 
	 * if (t1 == InnerType.Side && t2 == InnerType.SidePair) { if
	 * (n1.getSingleSide().getRoad().getID().getValue() ==
	 * n2.getSidePair().getLeft().getRoad().getID().getValue()) { return
	 * cost(n1.getSingleSide(), n2.getSidePair().getLeft()); }
	 * 
	 * if (n1.getSingleSide().getRoad().getID().getValue() ==
	 * n2.getSidePair().getRight().getRoad().getID().getValue()) { return
	 * cost(n1.getSingleSide(), n2.getSidePair().getRight()); } }
	 * 
	 * // EE - EE if (t1 == InnerType.SidePair && t2 == InnerType.SidePair) {
	 * int t1a = n1.getSidePair().getLeft().getRoad().getID().getValue(); int
	 * t1b = n1.getSidePair().getRight().getRoad().getID().getValue(); int t2a =
	 * n2.getSidePair().getLeft().getRoad().getID().getValue(); int t2b =
	 * n2.getSidePair().getRight().getRoad().getID().getValue(); if (t1a == t2a)
	 * { // LL return cost(n1.getSidePair().getLeft(),
	 * n2.getSidePair().getLeft()); }
	 * 
	 * if (t1a == t2b) { // LR return cost(n1.getSidePair().getLeft(),
	 * n2.getSidePair().getRight()); }
	 * 
	 * if (t1b == t2a) { // RL return cost(n1.getSidePair().getRight(),
	 * n2.getSidePair().getLeft()); }
	 * 
	 * if (t1b == t2b) { // RR return cost(n1.getSidePair().getRight(),
	 * n2.getSidePair().getRight()); } }
	 * 
	 * throw new IllegalArgumentException("n1,n2 bad type"); }
	 */
}
