package ant.utils;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.Set;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.EntityID;

/**
 * 
 * @author Ivan
 * 
 */
public class AreaInConnectedRange {

	public static Set<Area> getAreaInConnectedRange(StandardWorldModel world, Area from, int range) {
		Set<Area> ret = new HashSet<Area>(200);
		LinkedList<Area> current = new LinkedList<Area>();
		current.add(from);
		ret.add(from);
		int cx = from.getX();
		int cy = from.getY();
		Area t, r;
		while (!current.isEmpty()) {
			t = current.poll();
			for (EntityID id : t.getNeighbours()) {
				r = (Area) world.getEntity(id);
				if (!ret.contains(r)) {
					if (Math.abs(r.getX() - cx) + Math.abs(r.getY() - cy) <= range) {
						ret.add(r);
						current.add(r);
					}
				}
			}
		}
		return ret;
	}
}
