package ant.utils;

import java.util.ArrayList;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * 
 * @author Oliver
 * 
 */
public class CombinationTraversal {
	private static Log log = LogFactory.getLog(CombinationTraversal.class);

	/**
	 * 
	 * @param totalCount
	 *            should be positive integer
	 * @param needCount
	 *            should be positive integer and no larger than needCount
	 * @return the ArraryList that contains the traversal combinations
	 */
	public static ArrayList<int[]> getCombinations(int totalCount, int needCount) {
		ArrayList<int[]> rv = new ArrayList<int[]>();

		if (needCount > totalCount) {
			needCount = totalCount;
			log.error("needCount > totalCount, with needCount " + needCount + " and totalCount "
					+ totalCount);
		}
		if (needCount == 0) {
			return rv;
		}

		int[] indexs = new int[needCount];
		// initial step
		for (int i = 0; i < needCount; i++) {
			indexs[i] = i;
		}
		while (true) {
			// clone is needed
			rv.add(indexs.clone());
			// find change digit
			int digit = needCount - 1;
			while (true) {
				if (digit == -1) {
					// there is no such digit, we finished
					return rv;
				} else if (indexs[digit] == totalCount - (needCount - digit)) {
					// decrease the digit
					digit--;
					continue;
				} else {
					// find digit here
					break;
				}
			}
			// try change digit
			{
				for (int i = 0; i < digit; i++) {
					// keep the same for former digits
				}
				indexs[digit] = indexs[digit] + 1;
				for (int i = digit + 1; i < needCount; i++) {
					indexs[i] = indexs[i - 1] + 1;
				}
			}
		}
	}
}
