package ant.utils;

import java.util.Map;

/**
 * 
 * @author Ivan
 *
 */
public class CounterSet<E> {
	
	private Map<E, Integer> inner;
	
	public CounterSet() {
		inner = new LazyMap<E, Integer>() {
			@Override
			public Integer createValue() {
				return 0;
			}
		};
	}
	
	public boolean contains(E e) {
		return inner.containsKey(e);
	}
	
	public int count(E e) {
		if (!inner.containsKey(e)) {
			return 0;
		}
		
		return inner.get(e);
	}
	
	public void inc(E e) {
		inner.put(e, inner.get(e) + 1);
	}
	
	public void clearItem(E e) {
		inner.put(e, 0);
	}
	
	public void clear() {
		this.inner.clear();
	}
	
	public Map<E, Integer> getMap() {
		return inner;
	}
}
