package ant.utils;

import java.util.Map;
import java.util.Random;

/**
 * 
 * @author Ivan
 * 
 * TODO test, 0 value or inifinate value judge
 */
public class NormWeightedRandomSelector {
	private static final int T = Integer.MAX_VALUE;
	
	public static <E> E probabilitySelect(final Map<E, Double> input, Random rand) {
		Double sum = 0.0;
		for (Map.Entry<E, Double> entry : input.entrySet()) {
			sum += entry.getValue();
		}
		if (sum.isInfinite()) {
			return RandomSelector.randomSelect(input.keySet(), 1, rand).iterator().next();
		}
		
		int rr = rand.nextInt(T);
		for (Map.Entry<E, Double> entry : input.entrySet()) {
			int temp = (int) (entry.getValue() * T / sum);
			if (temp >= rr) 
				return entry.getKey();
			rr -= temp;
		}
		
		return RandomSelector.randomSelect(input.keySet(), 1, rand).iterator().next();
	}
	
}
