package ant.utils.blockade;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.EntityID;
import ant.utils.Pair;
import ant.utils.geo.Converter;
import ant.utils.geo.Segment;

/**
 * 
 * @author Ivan
 *
 */
public class SubPassLineUtils {
	private static final int SAMPLING = 16;
	
	public static Set<Pair<Edge, Segment>> getSubPassLine(Road r, StandardWorldModel world) {
		Set<Pair<Edge, Segment>> ss = new HashSet<Pair<Edge,Segment>>();
		
		if (r.isBlockadesDefined()) {
			if (r.getBlockades().size() != 0) {
				List<Blockade> blks = genblocks(r.getBlockades(), world);
				for (Edge e : r.getEdges()) {
					if (e.isPassable()) {
						Segment edgeline = Converter.generateSegment(e);
						boolean[] samplingcross = new boolean[SAMPLING];
						for (int i = 0; i < SAMPLING; i++) {
							Segment vertical = genvertical(edgeline, i);
							samplingcross[i] = cross(vertical, blks);
						}
						Segment pass = genpass(edgeline, samplingcross);
						ss.add(new Pair<Edge, Segment>(e, pass));
					}
				}
				return ss;
			}
		}
		
		// NonBlock
		for (Edge e : r.getEdges()) {
			if (e.isPassable()) {
				ss.add(new Pair<Edge, Segment>(e, Converter.generateSegment(e)));
			}
		}
		return ss;
	}
	
	private static Segment genpass(Segment edgeline, boolean[] samplingcross) {
		// TODO Auto-generated method stub
		return null;
	}

	private static boolean cross(Segment vertical, List<Blockade> blks) {
		// TODO Auto-generated method stub
		return false;
	}

	private static Segment genvertical(Segment edgeline, int i) {
		// TODO Auto-generated method stub
		return null;
	}

	private static List<Blockade> genblocks(List<EntityID> input, StandardWorldModel world) {
		List<Blockade> output = new ArrayList<Blockade>();
		for (EntityID id : input) {
			output.add((Blockade) world.getEntity(id));
		}
		return output;
	}
}
