package ant.utils.blockade;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.EntityID;
import ant.utils.geo.Polygon;
import ant.utils.geo.acc.AccUtils;

/**
 * 
 * @author Fun
 *
 */
public class WrappedRoad extends Road {
	private static Log log = LogFactory.getLog(WrappedRoad.class);
	
	private List<Blockade> blockEntities = null;
	private StandardWorldModel world = null;
	private List<Polygon> expBlockades = null;

	public WrappedRoad(EntityID id,List<Blockade> blockEntities) {
		super(id);
		this.blockEntities = blockEntities;
	}

	public WrappedRoad(Road other,List<Blockade> blockEntities) {
		super(other);
		this.blockEntities = blockEntities;
	}
	
	public WrappedRoad(Road other, StandardWorldModel world){
		super(other);
		
		this.world = world;
		blockEntities = new ArrayList<Blockade>();
		if(other.isBlockadesDefined()){
			List<EntityID> bIds = other.getBlockades();
			for(EntityID next: bIds){
				Blockade blockade = (Blockade) world.getEntity(next);
				blockEntities.add(blockade);
			}
		}
	}

	public List<Blockade> getBlockEntities() {
		if(blockEntities == null){
			blockEntities = new ArrayList<Blockade>();
			if(this.isBlockadesDefined()&&(world != null)){
				List<EntityID> bIds = this.getBlockades();
				for(EntityID next: bIds){
					Blockade blockade = (Blockade) world.getEntity(next);
					blockEntities.add(blockade);
				}
			}
		}
		return blockEntities;
	}
	
	public List<Polygon> getExpBlockades(){
		if(expBlockades == null){
			expBlockades = new ArrayList<Polygon>();
			for(Blockade blockade: getBlockEntities()){
				expBlockades.add(new Polygon(AccUtils.expandPolygon(blockade.getApexes(), RoadUtils.RESCUE_AGENT_RADIUS ,true)));
			}
		}
		return expBlockades;
	}
	
	@Override
	public String toString() {
		return super.toString();
	}
	
}
