package ant.utils.civilian;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import ant.component.at.AmbulanceMemComponent;

/**
 * 
 * @author Fun
 * 
 */
// FIXME distCost dist
public class AssignInfo {
	/**
	 * <Assigned Agent, To Save Human>
	 */
	private Map<EntityID, EntityID> m_assign;
	/**
	 * ??????????????????????????????? TODO
	 */
	private Map<EntityID, IntValue> m_beAssigned;
	/**
	 * 可以被救的人的集合？
	 */
	private Set<EntityID> m_savedCiv;

	// private Map<EntityID,Integer> m_needATTable;

	private AmbulanceMemComponent amc;

	public AssignInfo(List<CivilianInfo> civs, AmbulanceMemComponent amc) {
		this.amc = amc;
		m_assign = new HashMap<EntityID, EntityID>();
		m_beAssigned = new HashMap<EntityID, IntValue>();
		m_savedCiv = new HashSet<EntityID>();
		// m_needATTable = new HashMap<EntityID, Integer>();

		SimulationElement se;
		for (Iterator it = civs.iterator(); it.hasNext();) {
			CivilianInfo c = (CivilianInfo) it.next();
			se = new SimulationElement(c.getID().getValue(), amc);
			// m_needATTable.put(c.getID(),
			// se.getNumATNeeded(amc.getCurrentTime()+7));
		}
	}

	public Map<EntityID, EntityID> getAssignation() {
		return m_assign;
	}

	public Map<EntityID, IntValue> getCivBeAssigned() {
		return m_beAssigned;
	}

	public Set<EntityID> getSavedCiv() {
		return m_savedCiv;
	}

	public void assign(EntityID agentID, EntityID cid) {
		m_assign.put(agentID, cid);
		if (m_beAssigned.containsKey(cid))
			m_beAssigned.get(cid).value++;
		else
			m_beAssigned.put(cid, new IntValue(1));

		// if(m_beAssigned.get(cid).value >= m_needATTable.get(cid))
		// m_savedCiv.add(cid);
		if (m_savedCiv.contains(cid))
			return;
		int a = 0;
		int b = 0;

		CivilianInfo ci = amc.getCivilianInfoMap().get(cid);

		Iterator<Entry<EntityID, EntityID>> it = m_assign.entrySet().iterator();

		while (it.hasNext()) {
			Entry<EntityID, EntityID> entry = it.next();
			EntityID atID = entry.getKey();
			EntityID civID = entry.getValue();

			if (!civID.equals(cid)) {
				continue;
			}
			EntityID atPosition = amc.getAmbulanceTeamPosition(atID);

			if (atPosition.equals(ci.getPosition())) {
				a++;
			} else {
				b++;
			}

		}
		// ref origin
		/*
		 * for(Iterator it = m_assign.keySet().iterator();it.hasNext();){ int
		 * atID = (Integer)it.next(); int civID = m_assign.get(atID); if(civID
		 * != cid) continue;
		 * 
		 * if( ((MovingObject)m_memory.lookup(atID)).getPosition() ==
		 * ((MovingObject)m_memory.lookup(civID)).getPosition() ) a++; else b++;
		 * }
		 */
		int bury = ci.getBuriedness();
		int saveTime = 0;
		if (bury < a * 7)
			saveTime = amc.getCurrentTime() + bury / a + 1;
		else
			saveTime = amc.getCurrentTime() + 7 + (bury - a * 7) / (b + a) + 1;
		if (saveTime < ci.getTimeToDie() - 5)
			m_savedCiv.add(cid);
	}

	public void remove(EntityID agentID) {
		EntityID cid = m_assign.get(agentID);
		m_assign.remove(agentID);
		m_beAssigned.get(cid).value--;
		// if(m_beAssigned.get(cid).value < m_needATTable.get(cid))
		// m_savedCiv.remove(cid);
		if (m_beAssigned.get(cid).value <= 0)
			m_beAssigned.remove(cid);

		if (m_savedCiv.contains(cid))
			m_savedCiv.remove(cid);
		//
		int a = 0;
		int b = 0;

		CivilianInfo ci = amc.getCivilianInfoMap().get(cid);

		Iterator<Entry<EntityID, EntityID>> it = m_assign.entrySet().iterator();
		while (it.hasNext()) {
			Entry<EntityID, EntityID> entry = it.next();
			EntityID atID = entry.getKey();
			EntityID civID = entry.getValue();
			if (!civID.equals(cid)) {
				continue;
			}
			if (amc.getAmbulanceTeamPosition(atID).equals(ci.getPosition())) {
				a++;
			} else {
				b++;
			}
		}

		// ref origin
		/*
		 * for(Iterator it = m_assign.keySet().iterator();it.hasNext();) { int
		 * atID = (Integer)it.next(); int civID = m_assign.get(atID); if(civID
		 * != cid) continue; if(
		 * ((MovingObject)m_memory.lookup(atID)).getPosition() ==
		 * ((MovingObject)m_memory.lookup(civID)).getPosition() ) a++; else b++;
		 * }
		 */
		if (a == 0 && b == 0)
			return;
		int bury = ci.getBuriedness();
		int saveTime = 0;
		if (bury < a * 7)
			saveTime = amc.getCurrentTime() + bury / a + 1;
		else
			saveTime = amc.getCurrentTime() + 7 + (bury - a * 7) / (b + a) + 1;
		if (saveTime < ci.getTimeToDie() - 5)
			m_savedCiv.add(cid);
	}

	public void dealLowMargin(Map<EntityID, Integer> assignMargin,
			Map<EntityID, Integer> rescueMargin) {
		EntityID bestTarget = null;
		int minMargin = 6;

		Iterator<Entry<EntityID, Integer>> it_am = assignMargin.entrySet()
				.iterator();

		while (it_am.hasNext()) {
			Entry<EntityID, Integer> entry = it_am.next();
			EntityID cid = entry.getKey();
			int margin = entry.getValue();

			if (m_beAssigned.containsKey(cid)) {
				continue;
			}
			if (margin < minMargin) {
				minMargin = margin;
				bestTarget = cid;
			}
		}

		/*
		 * ref origin for(Iterator it =
		 * m_assignMargin.keySet().iterator();it.hasNext();) { int cid =
		 * (Integer)it.next(); int margin = m_assignMargin.get(cid);
		 * //CivilianInfo c = (CivilianInfo)m_memory.lookup(cid);
		 * //if(c.m_rescuePower > 0) // continue;
		 * if(m_beAssigned.containsKey(cid)) continue; if(margin < minMargin) {
		 * minMargin = margin; bestTarget = cid; } }
		 */
		if (bestTarget == null) {
			return;
		}

		CivilianInfo target = amc.getCivilianInfoMap().get(bestTarget);
		// List of AT
		ArrayList<EntityID> source = new ArrayList<EntityID>();
		Iterator<Entry<EntityID, EntityID>> it_a = m_assign.entrySet()
				.iterator();
		while (it_a.hasNext()) {
			Entry<EntityID, EntityID> entry = it_a.next();
			CivilianInfo ci = amc.getCivilianInfoMap().get(entry.getValue());
			if (ci.getRescuePriority() > target.getRescuePriority()) {
				source.add(entry.getKey());
			}

		}

		/**
		 * ref origin for(Iterator it =
		 * m_assign.keySet().iterator();it.hasNext();) { int atID =
		 * (Integer)it.next(); int cid = m_assign.get(atID); CivilianInfo c =
		 * (CivilianInfo)m_memory.lookup(cid); if(c.getRescuePriority() >
		 * target.getRescuePriority()) source.add(atID); }
		 */
		if (source.isEmpty()) {
			return;
		}

		EntityID bestSource = null;
		double bestScore = Double.MIN_VALUE;

		Iterator<EntityID> it_s = source.iterator();
		while (it_s.hasNext()) {
			EntityID atId = it_s.next();
			EntityID orgCivId = m_assign.get(atId);
			// TODO
			if (rescueMargin.get(orgCivId) < 15) {
				continue;
			}
			CivilianInfo orgCiv = amc.getCivilianInfoMap().get(orgCivId);
			if (orgCiv.getBuriedness() == 0) {
				continue;
			}

			long dist = amc.manhattanDistance(atId,
					StandardEntityURN.AMBULANCE_TEAM, target.getID(),
					StandardEntityURN.CIVILIAN);
			long distCost = dist
					- amc.manhattanDistance(atId,
							StandardEntityURN.AMBULANCE_TEAM, orgCiv.getID(),
							StandardEntityURN.CIVILIAN);
			double score = (double) orgCiv.getBuriedness()
					/ this.getCivBeAssigned().get(orgCiv.getID()).value;
			score = score / distCost;
			if (score < 0) {
				score = 1000;
			}
			if (score > bestScore) {
				bestScore = score;
				bestSource = atId;
			}
		}
		/**
		 * ref origin for(Iterator it = source.iterator();it.hasNext();) { int
		 * atID = (Integer)it.next(); int orgCivID = m_assign.get(atID);
		 * 
		 * if(m_rescueMargin.get(orgCivID) < 15) continue; CivilianInfo orgCiv =
		 * (CivilianInfo)m_memory.lookup(orgCivID);
		 * if(orgCiv.getBuriedness()==0) continue; //// //// int dist =
		 * m_memory.m_pathPlanner.lookupDistance(atID, target.getID()); int
		 * distCost = dist - getPathPlanner().lookupDistance(atID,
		 * orgCiv.getID()); double score =
		 * (double)orgCiv.getBuriedness()/getCivBeAssigned
		 * ().get(orgCiv.getID()).value; score = score/distCost; if(score < 0)
		 * score = 1000; if(score > bestScore) { bestScore = score; bestSource =
		 * atID; } }
		 */
		//
		if (bestSource == null) {
			return;
		}
		remove(bestSource);
		assign(bestSource, target.getID());
		// System.out.println("Deal low margin!");
	}

	public void dealRidiculous(Map<EntityID, EntityID> greedyAssign) {
		ArrayList<EntityID> adjustAT = new ArrayList<EntityID>();
		Iterator<Entry<EntityID, IntValue>> it_cba = getCivBeAssigned()
				.entrySet().iterator();
		while (it_cba.hasNext()) {
			Entry<EntityID, IntValue> entry = it_cba.next();
			EntityID cid = entry.getKey();
			int power = entry.getValue().value;
			CivilianInfo ci = amc.getCivilianInfoMap().get(cid);
			if (ci.getBuriedness() == 0 && power > 1) {
				long minDist = Integer.MAX_VALUE;
				EntityID bestATID = null;

				Iterator<Entry<EntityID, EntityID>> it_a = m_assign.entrySet()
						.iterator();
				while (it_a.hasNext()) {
					Entry<EntityID, EntityID> en = it_a.next();
					EntityID atID = en.getKey();
					if (!m_assign.get(atID).equals(cid)) {
						continue;
					}
					long dist = amc.manhattanDistance(atID,
							StandardEntityURN.AMBULANCE_TEAM, cid,
							StandardEntityURN.CIVILIAN);
					if (dist < minDist) {
						minDist = dist;
						bestATID = atID;
					}
				}
				// ////
				it_a = m_assign.entrySet().iterator();
				while (it_a.hasNext()) {
					Entry<EntityID, EntityID> en = it_a.next();
					EntityID atID = en.getKey();
					if (m_assign.get(atID) == cid && atID != bestATID)
						adjustAT.add(atID);
				}

			}
		}
		/**
		 * for(Iterator it =
		 * getCivBeAssigned().keySet().iterator();it.hasNext();) { int cid =
		 * (Integer)it.next(); int power = getCivBeAssigned().get(cid).value;
		 * CivilianInfo c = (CivilianInfo)m_memory.lookup(cid);
		 * if(c.getBuriedness()==0 && power > 1) { int minDist =
		 * Integer.MAX_VALUE; int bestATID = -1; for(Iterator it2 =
		 * m_assign.keySet().iterator();it2.hasNext();) { int atID =
		 * (Integer)it2.next(); if(m_assign.get(atID)!=cid) continue; int dist =
		 * m_memory.m_pathPlanner.lookupDistance(atID, cid); if(dist < minDist)
		 * { minDist = dist; bestATID = atID; } } // for(Iterator it2 =
		 * m_assign.keySet().iterator();it2.hasNext();) { int atID =
		 * (Integer)it2.next(); if(m_assign.get(atID)==cid && atID != bestATID)
		 * adjustAT.add(atID); } } }
		 */

		//
		for (EntityID next : adjustAT) {
			remove(next);
		}
		//
		for (EntityID next : adjustAT) {
			assign(next, greedyAssign.get(next));
		}
	}

	public void adjust(Map<EntityID, EntityID> greedyAssign) {
		ArrayList<EntityID> removeList = new ArrayList<EntityID>();
		Iterator<Entry<EntityID, EntityID>> it = m_assign.entrySet().iterator();
		while (it.hasNext()) {
			Entry<EntityID, EntityID> entry = it.next();
			long at_civ_dist = amc.manhattanDistance(entry.getKey(),
					StandardEntityURN.AMBULANCE_TEAM, entry.getValue(),
					StandardEntityURN.CIVILIAN);
			if (at_civ_dist < Integer.MAX_VALUE / 2000) // TODO
				continue;
			removeList.add(entry.getKey());
		}
		/**
		 * ref origin for(Iterator it =
		 * m_assign.keySet().iterator();it.hasNext();){ int atID =
		 * (Integer)it.next(); int civID = m_assign.get(atID);
		 * if(m_memory.m_pathPlanner.lookupDistance(atID, civID) <
		 * Integer.MAX_VALUE/2000) continue; removeList.add(atID);
		 * //remove(atID); //int newTask = assignNewTask(atID, this);
		 * //assign(atID,newTask); }
		 */
		for (EntityID next : removeList) {
			remove(next);
		}
		for (EntityID next : removeList) {
			assign(next, greedyAssign.get(next));
		}
		//
		// removeAssignForExploration();
		//
	}

	public void removeAssignForExploration(
			List<CivilianInfo> rescueableCollectionBackup) {
		for (CivilianInfo ci : rescueableCollectionBackup) {
			if (!getCivBeAssigned().containsKey(ci.getID())) {
				return;
			}
			SimulationElement se = new SimulationElement(ci.getID().getValue(),
					amc);
			if (se.getNumATNeeded(amc.getCurrentTime() + 7) > this
					.getCivBeAssigned().get(ci.getID()).value) {
				return;
			}
		}

		//
		for (CivilianInfo ci : rescueableCollectionBackup) {
			SimulationElement se = new SimulationElement(ci.getID().getValue(),
					amc);
			int extraPower = getCivBeAssigned().get(ci.getID()).value
					- se.getNumATNeeded(amc.getCurrentTime() + 7);
			List<DistProperty> arrayDist = new ArrayList<DistProperty>();
			for (Entry<EntityID, EntityID> next : m_assign.entrySet()) {
				EntityID atID = next.getKey();
				EntityID civID = next.getValue();
				if (civID.equals(ci.getID())) {
					long at_civ_dist = amc.manhattanDistance(atID,
							StandardEntityURN.AMBULANCE_TEAM, civID,
							StandardEntityURN.CIVILIAN);
					arrayDist.add(new DistProperty(atID, at_civ_dist));
				}
				Collections.sort(arrayDist);
				for (int j = 0; j < extraPower; j++) {
					remove(arrayDist.get(0).m_id);
					arrayDist.remove(0);
				}
			}
		}
	}
	//
}
