package ant.utils.civilian;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import rescuecore2.standard.entities.Building;
import rescuecore2.worldmodel.EntityID;

/**
 * 
 * @author Fun
 *
 */
public class BuriedAgentInfo {
	private static Log log = LogFactory.getLog(BuriedAgentInfo.class);
	
	private EntityID agentID;
	private int hp;
	private int damage;
	private int buriedness;
	private Building building;
	private int deathTime;
	private int lastUpdateTime;
		
	public BuriedAgentInfo(EntityID agentID, int hp, int damage,
			int buriedness, Building building, int deathTime, int lastUpdateTime) {
		super();
		this.agentID = agentID;
		this.hp = hp;
		this.damage = damage;
		this.buriedness = buriedness;
		this.building = building;
		this.deathTime = deathTime;
		this.lastUpdateTime = lastUpdateTime;
	}

	public EntityID getAgentID() {
		return agentID;
	}

	public int getHp() {
		return hp;
	}

	public int getDamage() {
		return damage;
	}

	public int getBuriedness() {
		return buriedness;
	}

	public Building getBuilding() {
		return building;
	}

	public int getDeathTime() {
		return deathTime;
	}
	
	public int getLastUpdateTime() {
		return lastUpdateTime;
	}
	
	public void update(int hp, int dmg, int buriedness, int deathTime, int lastUpdateTime){
		if(lastUpdateTime < this.lastUpdateTime){
			return;
		}
		this.hp = hp;
		this.damage = dmg;
		this.buriedness = buriedness;
		this.deathTime = deathTime;
		this.lastUpdateTime = lastUpdateTime;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((agentID == null) ? 0 : agentID.hashCode());
		result = prime * result
				+ ((building == null) ? 0 : building.hashCode());
		result = prime * result + buriedness;
		result = prime * result + damage;
		result = prime * result + deathTime;
		result = prime * result + hp;
		result = prime * result + lastUpdateTime;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BuriedAgentInfo other = (BuriedAgentInfo) obj;
		if (agentID == null) {
			if (other.agentID != null)
				return false;
		} else if (!agentID.equals(other.agentID))
			return false;
		if (building == null) {
			if (other.building != null)
				return false;
		} else if (!building.equals(other.building))
			return false;
		if (buriedness != other.buriedness)
			return false;
		if (damage != other.damage)
			return false;
		if (deathTime != other.deathTime)
			return false;
		if (hp != other.hp)
			return false;
		if (lastUpdateTime != other.lastUpdateTime)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "BuriedAgentInfo [agentID=" + agentID + ", hp=" + hp
				+ ", damage=" + damage + ", buriedness=" + buriedness
				+ ", building=" + building + ", deathTime=" + deathTime
				+ ", lastUpdateTime=" + lastUpdateTime + "]";
	}

}
