package ant.utils.comparator;

import java.util.Comparator;

import rescuecore2.standard.entities.Edge;

/**
 * longer edge in the head of list
 * 
 * @author Oliver
 */
public class EdgeLengthComparator implements Comparator<Edge> {
	@Override
	public int compare(Edge o1, Edge o2) {
		double l1 = getLength(o1);
		double l2 = getLength(o2);
		if (l1 < l2) {
			return 1;
		} else if (l1 > l2) {
			return -1;
		} else {
			return 0;
		}
	}

	public static double getLength(Edge e) {
		int dx = e.getStartX() - e.getEndX();
		int dy = e.getStartY() - e.getEndY();
		double length = Math.sqrt(1.0 * dx * dx + 1.0 * dy * dy);
		return length;
	}

}
