#!/bin/bash

CP="jars/ant.jar:\
jars/commons-logging.jar:\
jars/dom4j.jar:\
jars/jaxen-1.1.1.jar:\
jars/jcommon-1.0.16.jar:\
jars/jfreechart-1.0.13.jar:\
jars/jgrapht-jdk1.5-0.7.3.jar:\
jars/jsi-1.0b2p1.jar:\
jars/log4j-1.2.15.jar:\
jars/rescuecore.jar:\
jars/rescuecore2.jar:\
jars/resq-fire.jar:\
jars/standard.jar:\
jars/trove-0.1.8.jar:\
jars/traffic3.jar:\
jars/uncommons-maths-1.2.jar"

if [ $# -ne 7 ];
then
    echo "Usage: start.sh fb fs pf po at ac host"
	echo "Sample: start.sh -1 -1 0 0 0 0 127.0.0.1"
    exit 1
fi

fb=$1
fs=$2
pf=$3
po=$4
at=$5
ac=$6
host=$7

echo $fb $fs $pf $po $at $ac $host
echo $CP

java -Xmx5g -Xms2g -cp $CP ant.agent.ServerLauncher --random.seed=1 -fb $fb -fs $fs -pf $pf -po $po -at $at -ac $ac -h $host
